package at.cl.atp.foresolution.exceptions;

import at.cl.atp.foresolution.model.Formula;

public class NotUnifiableException extends RuntimeException {

	private static final long serialVersionUID = 1L;

	private final Formula left;
	private final Formula right;

	public NotUnifiableException(final Formula left, final Formula right) {
		this.left = left;
		this.right = right;
	}

	@Override
	public String getMessage() {
		StringBuilder builder = new StringBuilder();
		builder.append("The formula ");
		builder.append(this.left.toString());
		builder.append(" is not unifiable with ");
		builder.append(this.right.toString());
		return builder.toString();
	}

}
