package at.cl.atp.foresolution.model;

import at.cl.atp.foresolution.model.enums.AtomType;
import at.cl.atp.foresolution.model.utils.FormulaFormatter;

public class Atom extends Formula {

	private final AtomType type;
	private final String name;

	/* default */Atom(final AtomType type, final String name) {
		this.type = type;
		this.name = name;
	}

	public AtomType getType() {
		return this.type;
	}

	public String getName() {
		return this.name;
	}

	@Override
	public boolean contentEquals(final Formula other) {
		// guarded by TermRegistry, we create each atom only once
		return other == this;
	}

	@Override
	public String toString() {
		return FormulaFormatter.formatIdentifier(this.name);
	}

}
