package at.cl.atp.foresolution.model;

public class NegatedFormula extends Formula {

	private final Formula innerFormula;

	/* default */NegatedFormula(final long innerFormulaID) {
		this(TermRegistry.getByID(innerFormulaID));
	}

	/* default */NegatedFormula(final Formula innerFormula) {
		this.innerFormula = innerFormula;
	}

	public Formula getInnerFormula() {
		return this.innerFormula;
	}

	@Override
	public boolean contentEquals(final Formula other) {
		// guarded by TermRegistry, we create each negation only once
		return other == this;
	}

	@Override
	public String toString() {
		return "!(" + this.innerFormula.toString() + ")";
	}

}
