package at.cl.atp.foresolution.model.clause;

import at.cl.atp.foresolution.model.substitution.Substitution;

public class ClashInfo {

	private final Clause firstClause;
	private final Clause secondClause;
	private final ClauseLiteral firstLiteral;
	private final ClauseLiteral secondLiteral;
	private final Substitution mgu;

	public ClashInfo(final Clause firstClause, final Clause secondClause, final ClauseLiteral firstLiteral,
			final ClauseLiteral secondLiteral, final Substitution mgu) {
		super();
		this.firstClause = firstClause;
		this.secondClause = secondClause;
		this.firstLiteral = firstLiteral;
		this.secondLiteral = secondLiteral;
		this.mgu = mgu;
	}

	public Clause getFirstClause() {
		return this.firstClause;
	}

	public Clause getSecondClause() {
		return this.secondClause;
	}

	public ClauseLiteral getFirstLiteral() {
		return this.firstLiteral;
	}

	public ClauseLiteral getSecondLiteral() {
		return this.secondLiteral;
	}

	public Substitution getMgu() {
		return this.mgu;
	}

}
