package at.cl.atp.foresolution.model.container;

import java.util.HashSet;
import java.util.Set;

import at.cl.atp.foresolution.model.Formula;
import at.cl.atp.foresolution.transformations.TransformationType;

public class FormulaContainer {

	private final Set<TransformationType> appliedTransformations;
	private Formula formula;
	private final SkolemNameProvider nameProvider;

	public FormulaContainer() {
		this(null);
	}

	public FormulaContainer(final Formula formula) {
		this.formula = formula;
		this.appliedTransformations = new HashSet<TransformationType>();
		this.nameProvider = new SkolemNameProvider();
	}

	public Formula getFormula() {
		return this.formula;
	}

	public void setFormula(final Formula formula) {
		this.formula = formula;
	}

	public Set<TransformationType> getAppliedTransformations() {
		return this.appliedTransformations;
	}

	public String nextSkolemVariable() {
		return this.nameProvider.nextSkolemVariable();
	}

	public String nextSkolemFunction() {
		return this.nameProvider.nextSkolemFunction();
	}

	public String nextSkolemPredicate() {
		return this.nameProvider.nextSkolemPredicate();
	}

	@Override
	public String toString() {
		return this.formula.toString();
	}
}
