package at.cl.atp.foresolution.model.utils;

import java.util.HashMap;
import java.util.Map;

public class BinaryKeyMap<K1, K2, V> {

	private final Map<K1, Map<K2, V>> contents;

	public BinaryKeyMap() {
		this.contents = new HashMap<K1, Map<K2, V>>();
	}

	public void put(final K1 key1, final K2 key2, final V value) {
		Map<K2, V> innerMap = this.contents.get(key1);
		if (innerMap == null) {
			innerMap = new HashMap<K2, V>();
			this.contents.put(key1, innerMap);
		}
		innerMap.put(key2, value);
	}

	public V get(final K1 key1, final K2 key2) {
		Map<K2, V> innerMap = this.contents.get(key1);
		if (innerMap == null) {
			return null;
		}
		return innerMap.get(key2);
	}

	public boolean containsKey(final K1 key1, final K2 key2) {
		Map<K2, V> innerMap = this.contents.get(key1);
		if (innerMap == null) {
			return false;
		}
		return innerMap.containsKey(key2);
	}

}
