package at.cl.atp.foresolution.model.utils;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

import at.cl.atp.foresolution.alphabet.GreekAlphabet;
import at.cl.atp.foresolution.settings.Settings;

public class FormulaFormatter {

	private static final Pattern numberPattern = Pattern.compile("[0-9]");

	public static String formatIdentifier(final String identifier) {
		String result = identifier;
		if (result.startsWith("_")) {
			// cut leading underscore
			result = result.substring(1);
		}
		Matcher matcher = numberPattern.matcher(result);
		if (matcher.find()) {
			int index = Integer.parseInt(matcher.group());
			if (index == 0) {
				// cut trailing index 0
				result = result.substring(result.length() - 2, result.length() - 1);
			}
		}
		if (Settings.greekLettersInOutput()) {
			return result;
		} else {
			// convert to latin
			StringBuilder builder = new StringBuilder();
			for (char character : result.toCharArray()) {
				if (GreekAlphabet.instance.contains(character)) {
					builder.append(GreekAlphabet.instance.toLatex(character));
				} else {
					builder.append(character);
				}
			}
			return builder.toString();
		}
	}
}
