package at.cl.atp.foresolution.model.utils;

import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;

public class SetUnion<T> implements Iterable<T> {

	private final Set<Set<T>> union;

	@SafeVarargs
	public SetUnion(final Set<T>... sets) {
		this.union = new HashSet<Set<T>>();
		for (Set<T> set : sets) {
			this.union.add(set);
		}
	}

	@Override
	public Iterator<T> iterator() {
		return new SetUnionIterator<T>(this.union);
	}

}
