package at.cl.atp.foresolution.model.utils;

import java.util.Iterator;
import java.util.NoSuchElementException;
import java.util.Set;

public class SetUnionIterator<T> implements Iterator<T> {

	private final Set<Set<T>> union;
	private final Iterator<Set<T>> setIterator;
	private Iterator<T> innerIterator;

	public SetUnionIterator(final Set<Set<T>> union) {
		this.union = union;
		this.setIterator = this.union.iterator();
		if (this.setIterator.hasNext()) {
			this.innerIterator = this.setIterator.next().iterator();
		} else {
			this.innerIterator = null;
		}
	}

	@Override
	public boolean hasNext() {
		if (this.innerIterator == null) {
			return false;
		}
		if (this.innerIterator.hasNext()) {
			return true;
		} else {
			if (this.setIterator.hasNext() == false) {
				return false;
			} else {
				while (this.setIterator.hasNext() && this.innerIterator.hasNext() == false) {
					this.innerIterator = this.setIterator.next().iterator();
				}
				return this.innerIterator.hasNext();
			}
		}
	}

	@Override
	public T next() {
		if (this.hasNext()) {
			return this.innerIterator.next();
		} else {
			throw new NoSuchElementException("No more elements in set union.");
		}
	}

	@Override
	public void remove() {
		throw new UnsupportedOperationException("Cannot remove from set union.");
	}

}
