/*
* generated by Xtext
*/
package at.cl.atp.ui.labeling

import com.google.inject.Inject
import at.cl.atp.fOResolution.LowBindFormula
import at.cl.atp.fOResolution.Variable
import at.cl.atp.fOResolution.Constant
import at.cl.atp.fOResolution.Function
import at.cl.atp.fOResolution.Predicate
import at.cl.atp.fOResolution.NegatedFormula
import at.cl.atp.fOResolution.QuantifiedFormula
import at.cl.atp.fOResolution.Quantifier
import at.cl.atp.fOResolution.BinaryOperation

/**
 * Provides labels for a EObjects.
 * 
 * see http://www.eclipse.org/Xtext/documentation.html#labelProvider
 */
class FOResolutionLabelProvider extends org.eclipse.xtext.ui.label.DefaultEObjectLabelProvider {

	@Inject
	new(org.eclipse.emf.edit.ui.provider.AdapterFactoryLabelProvider delegate) {
		super(delegate);
	}

	def text(QuantifiedFormula formula){
		val StringBuilder builder = new StringBuilder();
		builder.append(formula.quantifier.literal);
		builder.append("[");
		val int max = formula.variables.size;
		(0 ..< max).forEach[index |
			builder.append(formula.variables.get(index));
			if((index+1) < max){
				builder.append(", ");
			}
		]
		builder.append("]");
		return builder.toString();
	}
	
	def image(QuantifiedFormula formula){
		switch(formula.quantifier){
			case Quantifier::EXISTENTIAL: return "exists.png"
			case Quantifier::UNIVERSAL: return "forall.png"
		}
	}
	
	
	def text(LowBindFormula formula){
		switch(formula.operation){
			case BinaryOperation::CONJUNCTION: return 'and'
			case BinaryOperation::DISJUNCTION: return 'or'
			case BinaryOperation::IMPLICATION: return '->'
		}
	}
	
	def image(LowBindFormula formula){
		switch(formula.operation){
			case BinaryOperation::CONJUNCTION: return 'conjunction.png'
			case BinaryOperation::DISJUNCTION: return 'disjunction.png'
			case BinaryOperation::IMPLICATION: return 'implication.png'
		}
	}

	def image(Variable variable){
		return 'variable.png'
	}
	
	def image(Constant constant){
		return 'constant.png'
	}
	
	def image(Function function){
		return 'function.png'
	}
	
	def image(Predicate predicate){
		return 'predicate.png'
	}
	
	def text(NegatedFormula negation){
		return '!'
	}
	
	def image(NegatedFormula negation){
		return 'negation.png'
	}
	
}
