/**
 * generated by Xtext
 */
package at.cl.atp.ui.labeling;

import at.cl.atp.fOResolution.BinaryOperation;
import at.cl.atp.fOResolution.Constant;
import at.cl.atp.fOResolution.Function;
import at.cl.atp.fOResolution.LowBindFormula;
import at.cl.atp.fOResolution.NegatedFormula;
import at.cl.atp.fOResolution.Predicate;
import at.cl.atp.fOResolution.QuantifiedFormula;
import at.cl.atp.fOResolution.Quantifier;
import at.cl.atp.fOResolution.Variable;
import com.google.common.base.Objects;
import com.google.inject.Inject;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.edit.ui.provider.AdapterFactoryLabelProvider;
import org.eclipse.xtext.ui.label.DefaultEObjectLabelProvider;
import org.eclipse.xtext.xbase.lib.ExclusiveRange;
import org.eclipse.xtext.xbase.lib.IterableExtensions;
import org.eclipse.xtext.xbase.lib.Procedures.Procedure1;

/**
 * Provides labels for a EObjects.
 * 
 * see http://www.eclipse.org/Xtext/documentation.html#labelProvider
 */
@SuppressWarnings("all")
public class FOResolutionLabelProvider extends DefaultEObjectLabelProvider {
  @Inject
  public FOResolutionLabelProvider(final AdapterFactoryLabelProvider delegate) {
    super(delegate);
  }
  
  public String text(final QuantifiedFormula formula) {
    StringBuilder _stringBuilder = new StringBuilder();
    final StringBuilder builder = _stringBuilder;
    Quantifier _quantifier = formula.getQuantifier();
    String _literal = _quantifier.getLiteral();
    builder.append(_literal);
    builder.append("[");
    EList<String> _variables = formula.getVariables();
    final int max = _variables.size();
    ExclusiveRange _doubleDotLessThan = new ExclusiveRange(0, max, true);
    final Procedure1<Integer> _function = new Procedure1<Integer>() {
        public void apply(final Integer index) {
          EList<String> _variables = formula.getVariables();
          String _get = _variables.get((index).intValue());
          builder.append(_get);
          int _plus = ((index).intValue() + 1);
          boolean _lessThan = (_plus < max);
          if (_lessThan) {
            builder.append(", ");
          }
        }
      };
    IterableExtensions.<Integer>forEach(_doubleDotLessThan, _function);
    builder.append("]");
    return builder.toString();
  }
  
  public String image(final QuantifiedFormula formula) {
    String _switchResult = null;
    Quantifier _quantifier = formula.getQuantifier();
    final Quantifier _switchValue = _quantifier;
    boolean _matched = false;
    if (!_matched) {
      if (Objects.equal(_switchValue,Quantifier.EXISTENTIAL)) {
        _matched=true;
        return "exists.png";
      }
    }
    if (!_matched) {
      if (Objects.equal(_switchValue,Quantifier.UNIVERSAL)) {
        _matched=true;
        return "forall.png";
      }
    }
    return _switchResult;
  }
  
  public String text(final LowBindFormula formula) {
    String _switchResult = null;
    BinaryOperation _operation = formula.getOperation();
    final BinaryOperation _switchValue = _operation;
    boolean _matched = false;
    if (!_matched) {
      if (Objects.equal(_switchValue,BinaryOperation.CONJUNCTION)) {
        _matched=true;
        return "and";
      }
    }
    if (!_matched) {
      if (Objects.equal(_switchValue,BinaryOperation.DISJUNCTION)) {
        _matched=true;
        return "or";
      }
    }
    if (!_matched) {
      if (Objects.equal(_switchValue,BinaryOperation.IMPLICATION)) {
        _matched=true;
        return "->";
      }
    }
    return _switchResult;
  }
  
  public String image(final LowBindFormula formula) {
    String _switchResult = null;
    BinaryOperation _operation = formula.getOperation();
    final BinaryOperation _switchValue = _operation;
    boolean _matched = false;
    if (!_matched) {
      if (Objects.equal(_switchValue,BinaryOperation.CONJUNCTION)) {
        _matched=true;
        return "conjunction.png";
      }
    }
    if (!_matched) {
      if (Objects.equal(_switchValue,BinaryOperation.DISJUNCTION)) {
        _matched=true;
        return "disjunction.png";
      }
    }
    if (!_matched) {
      if (Objects.equal(_switchValue,BinaryOperation.IMPLICATION)) {
        _matched=true;
        return "implication.png";
      }
    }
    return _switchResult;
  }
  
  public String image(final Variable variable) {
    return "variable.png";
  }
  
  public String image(final Constant constant) {
    return "constant.png";
  }
  
  public String image(final Function function) {
    return "function.png";
  }
  
  public String image(final Predicate predicate) {
    return "predicate.png";
  }
  
  public String text(final NegatedFormula negation) {
    return "!";
  }
  
  public String image(final NegatedFormula negation) {
    return "negation.png";
  }
}
