/**
 */
package at.cl.atp.fOResolution;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>Binary Operation</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see at.cl.atp.fOResolution.FOResolutionPackage#getBinaryOperation()
 * @model
 * @generated
 */
public enum BinaryOperation implements Enumerator
{
  /**
   * The '<em><b>Implication</b></em>' literal object.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #IMPLICATION_VALUE
   * @generated
   * @ordered
   */
  IMPLICATION(0, "implication", "->"),

  /**
   * The '<em><b>Disjunction</b></em>' literal object.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #DISJUNCTION_VALUE
   * @generated
   * @ordered
   */
  DISJUNCTION(1, "disjunction", "or"),

  /**
   * The '<em><b>Conjunction</b></em>' literal object.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #CONJUNCTION_VALUE
   * @generated
   * @ordered
   */
  CONJUNCTION(2, "conjunction", "and");

  /**
   * The '<em><b>Implication</b></em>' literal value.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of '<em><b>Implication</b></em>' literal object isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @see #IMPLICATION
   * @model name="implication" literal="->"
   * @generated
   * @ordered
   */
  public static final int IMPLICATION_VALUE = 0;

  /**
   * The '<em><b>Disjunction</b></em>' literal value.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of '<em><b>Disjunction</b></em>' literal object isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @see #DISJUNCTION
   * @model name="disjunction" literal="or"
   * @generated
   * @ordered
   */
  public static final int DISJUNCTION_VALUE = 1;

  /**
   * The '<em><b>Conjunction</b></em>' literal value.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of '<em><b>Conjunction</b></em>' literal object isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @see #CONJUNCTION
   * @model name="conjunction" literal="and"
   * @generated
   * @ordered
   */
  public static final int CONJUNCTION_VALUE = 2;

  /**
   * An array of all the '<em><b>Binary Operation</b></em>' enumerators.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private static final BinaryOperation[] VALUES_ARRAY =
    new BinaryOperation[]
    {
      IMPLICATION,
      DISJUNCTION,
      CONJUNCTION,
    };

  /**
   * A public read-only list of all the '<em><b>Binary Operation</b></em>' enumerators.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static final List<BinaryOperation> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

  /**
   * Returns the '<em><b>Binary Operation</b></em>' literal with the specified literal value.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static BinaryOperation get(String literal)
  {
    for (int i = 0; i < VALUES_ARRAY.length; ++i)
    {
      BinaryOperation result = VALUES_ARRAY[i];
      if (result.toString().equals(literal))
      {
        return result;
      }
    }
    return null;
  }

  /**
   * Returns the '<em><b>Binary Operation</b></em>' literal with the specified name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static BinaryOperation getByName(String name)
  {
    for (int i = 0; i < VALUES_ARRAY.length; ++i)
    {
      BinaryOperation result = VALUES_ARRAY[i];
      if (result.getName().equals(name))
      {
        return result;
      }
    }
    return null;
  }

  /**
   * Returns the '<em><b>Binary Operation</b></em>' literal with the specified integer value.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static BinaryOperation get(int value)
  {
    switch (value)
    {
      case IMPLICATION_VALUE: return IMPLICATION;
      case DISJUNCTION_VALUE: return DISJUNCTION;
      case CONJUNCTION_VALUE: return CONJUNCTION;
    }
    return null;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private final int value;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private final String name;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private final String literal;

  /**
   * Only this class can construct instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private BinaryOperation(int value, String name, String literal)
  {
    this.value = value;
    this.name = name;
    this.literal = literal;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public int getValue()
  {
    return value;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getName()
  {
    return name;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getLiteral()
  {
    return literal;
  }

  /**
   * Returns the literal value of the enumerator, which is its string representation.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    return literal;
  }
  
} //BinaryOperation
