/**
 */
package at.cl.atp.fOResolution;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see at.cl.atp.fOResolution.FOResolutionFactory
 * @model kind="package"
 * @generated
 */
public interface FOResolutionPackage extends EPackage
{
  /**
   * The package name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNAME = "fOResolution";

  /**
   * The package namespace URI.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_URI = "http://www.cl.at/atp/FOResolution";

  /**
   * The package namespace name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_PREFIX = "fOResolution";

  /**
   * The singleton instance of the package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  FOResolutionPackage eINSTANCE = at.cl.atp.fOResolution.impl.FOResolutionPackageImpl.init();

  /**
   * The meta object id for the '{@link at.cl.atp.fOResolution.impl.FormulaImpl <em>Formula</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see at.cl.atp.fOResolution.impl.FormulaImpl
   * @see at.cl.atp.fOResolution.impl.FOResolutionPackageImpl#getFormula()
   * @generated
   */
  int FORMULA = 0;

  /**
   * The number of structural features of the '<em>Formula</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FORMULA_FEATURE_COUNT = 0;

  /**
   * The meta object id for the '{@link at.cl.atp.fOResolution.impl.QuantifiedFormulaImpl <em>Quantified Formula</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see at.cl.atp.fOResolution.impl.QuantifiedFormulaImpl
   * @see at.cl.atp.fOResolution.impl.FOResolutionPackageImpl#getQuantifiedFormula()
   * @generated
   */
  int QUANTIFIED_FORMULA = 1;

  /**
   * The feature id for the '<em><b>Quantifier</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int QUANTIFIED_FORMULA__QUANTIFIER = FORMULA_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Variables</b></em>' attribute list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int QUANTIFIED_FORMULA__VARIABLES = FORMULA_FEATURE_COUNT + 1;

  /**
   * The feature id for the '<em><b>Inner Formula</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int QUANTIFIED_FORMULA__INNER_FORMULA = FORMULA_FEATURE_COUNT + 2;

  /**
   * The number of structural features of the '<em>Quantified Formula</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int QUANTIFIED_FORMULA_FEATURE_COUNT = FORMULA_FEATURE_COUNT + 3;

  /**
   * The meta object id for the '{@link at.cl.atp.fOResolution.impl.NegatedFormulaImpl <em>Negated Formula</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see at.cl.atp.fOResolution.impl.NegatedFormulaImpl
   * @see at.cl.atp.fOResolution.impl.FOResolutionPackageImpl#getNegatedFormula()
   * @generated
   */
  int NEGATED_FORMULA = 2;

  /**
   * The feature id for the '<em><b>Inner Formula</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int NEGATED_FORMULA__INNER_FORMULA = FORMULA_FEATURE_COUNT + 0;

  /**
   * The number of structural features of the '<em>Negated Formula</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int NEGATED_FORMULA_FEATURE_COUNT = FORMULA_FEATURE_COUNT + 1;

  /**
   * The meta object id for the '{@link at.cl.atp.fOResolution.impl.PredicateImpl <em>Predicate</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see at.cl.atp.fOResolution.impl.PredicateImpl
   * @see at.cl.atp.fOResolution.impl.FOResolutionPackageImpl#getPredicate()
   * @generated
   */
  int PREDICATE = 3;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PREDICATE__NAME = FORMULA_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Arguments</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PREDICATE__ARGUMENTS = FORMULA_FEATURE_COUNT + 1;

  /**
   * The number of structural features of the '<em>Predicate</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PREDICATE_FEATURE_COUNT = FORMULA_FEATURE_COUNT + 2;

  /**
   * The meta object id for the '{@link at.cl.atp.fOResolution.impl.FunctionImpl <em>Function</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see at.cl.atp.fOResolution.impl.FunctionImpl
   * @see at.cl.atp.fOResolution.impl.FOResolutionPackageImpl#getFunction()
   * @generated
   */
  int FUNCTION = 4;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FUNCTION__NAME = FORMULA_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Arguments</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FUNCTION__ARGUMENTS = FORMULA_FEATURE_COUNT + 1;

  /**
   * The number of structural features of the '<em>Function</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FUNCTION_FEATURE_COUNT = FORMULA_FEATURE_COUNT + 2;

  /**
   * The meta object id for the '{@link at.cl.atp.fOResolution.impl.AtomImpl <em>Atom</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see at.cl.atp.fOResolution.impl.AtomImpl
   * @see at.cl.atp.fOResolution.impl.FOResolutionPackageImpl#getAtom()
   * @generated
   */
  int ATOM = 5;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ATOM__NAME = FORMULA_FEATURE_COUNT + 0;

  /**
   * The number of structural features of the '<em>Atom</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ATOM_FEATURE_COUNT = FORMULA_FEATURE_COUNT + 1;

  /**
   * The meta object id for the '{@link at.cl.atp.fOResolution.impl.VariableImpl <em>Variable</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see at.cl.atp.fOResolution.impl.VariableImpl
   * @see at.cl.atp.fOResolution.impl.FOResolutionPackageImpl#getVariable()
   * @generated
   */
  int VARIABLE = 6;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VARIABLE__NAME = ATOM__NAME;

  /**
   * The number of structural features of the '<em>Variable</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VARIABLE_FEATURE_COUNT = ATOM_FEATURE_COUNT + 0;

  /**
   * The meta object id for the '{@link at.cl.atp.fOResolution.impl.ConstantImpl <em>Constant</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see at.cl.atp.fOResolution.impl.ConstantImpl
   * @see at.cl.atp.fOResolution.impl.FOResolutionPackageImpl#getConstant()
   * @generated
   */
  int CONSTANT = 7;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONSTANT__NAME = ATOM__NAME;

  /**
   * The number of structural features of the '<em>Constant</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONSTANT_FEATURE_COUNT = ATOM_FEATURE_COUNT + 0;

  /**
   * The meta object id for the '{@link at.cl.atp.fOResolution.impl.LowBindFormulaImpl <em>Low Bind Formula</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see at.cl.atp.fOResolution.impl.LowBindFormulaImpl
   * @see at.cl.atp.fOResolution.impl.FOResolutionPackageImpl#getLowBindFormula()
   * @generated
   */
  int LOW_BIND_FORMULA = 8;

  /**
   * The feature id for the '<em><b>Left</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int LOW_BIND_FORMULA__LEFT = FORMULA_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Operation</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int LOW_BIND_FORMULA__OPERATION = FORMULA_FEATURE_COUNT + 1;

  /**
   * The feature id for the '<em><b>Right</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int LOW_BIND_FORMULA__RIGHT = FORMULA_FEATURE_COUNT + 2;

  /**
   * The number of structural features of the '<em>Low Bind Formula</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int LOW_BIND_FORMULA_FEATURE_COUNT = FORMULA_FEATURE_COUNT + 3;

  /**
   * The meta object id for the '{@link at.cl.atp.fOResolution.BinaryOperation <em>Binary Operation</em>}' enum.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see at.cl.atp.fOResolution.BinaryOperation
   * @see at.cl.atp.fOResolution.impl.FOResolutionPackageImpl#getBinaryOperation()
   * @generated
   */
  int BINARY_OPERATION = 9;

  /**
   * The meta object id for the '{@link at.cl.atp.fOResolution.Quantifier <em>Quantifier</em>}' enum.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see at.cl.atp.fOResolution.Quantifier
   * @see at.cl.atp.fOResolution.impl.FOResolutionPackageImpl#getQuantifier()
   * @generated
   */
  int QUANTIFIER = 10;


  /**
   * Returns the meta object for class '{@link at.cl.atp.fOResolution.Formula <em>Formula</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Formula</em>'.
   * @see at.cl.atp.fOResolution.Formula
   * @generated
   */
  EClass getFormula();

  /**
   * Returns the meta object for class '{@link at.cl.atp.fOResolution.QuantifiedFormula <em>Quantified Formula</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Quantified Formula</em>'.
   * @see at.cl.atp.fOResolution.QuantifiedFormula
   * @generated
   */
  EClass getQuantifiedFormula();

  /**
   * Returns the meta object for the attribute '{@link at.cl.atp.fOResolution.QuantifiedFormula#getQuantifier <em>Quantifier</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Quantifier</em>'.
   * @see at.cl.atp.fOResolution.QuantifiedFormula#getQuantifier()
   * @see #getQuantifiedFormula()
   * @generated
   */
  EAttribute getQuantifiedFormula_Quantifier();

  /**
   * Returns the meta object for the attribute list '{@link at.cl.atp.fOResolution.QuantifiedFormula#getVariables <em>Variables</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute list '<em>Variables</em>'.
   * @see at.cl.atp.fOResolution.QuantifiedFormula#getVariables()
   * @see #getQuantifiedFormula()
   * @generated
   */
  EAttribute getQuantifiedFormula_Variables();

  /**
   * Returns the meta object for the containment reference '{@link at.cl.atp.fOResolution.QuantifiedFormula#getInnerFormula <em>Inner Formula</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Inner Formula</em>'.
   * @see at.cl.atp.fOResolution.QuantifiedFormula#getInnerFormula()
   * @see #getQuantifiedFormula()
   * @generated
   */
  EReference getQuantifiedFormula_InnerFormula();

  /**
   * Returns the meta object for class '{@link at.cl.atp.fOResolution.NegatedFormula <em>Negated Formula</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Negated Formula</em>'.
   * @see at.cl.atp.fOResolution.NegatedFormula
   * @generated
   */
  EClass getNegatedFormula();

  /**
   * Returns the meta object for the containment reference '{@link at.cl.atp.fOResolution.NegatedFormula#getInnerFormula <em>Inner Formula</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Inner Formula</em>'.
   * @see at.cl.atp.fOResolution.NegatedFormula#getInnerFormula()
   * @see #getNegatedFormula()
   * @generated
   */
  EReference getNegatedFormula_InnerFormula();

  /**
   * Returns the meta object for class '{@link at.cl.atp.fOResolution.Predicate <em>Predicate</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Predicate</em>'.
   * @see at.cl.atp.fOResolution.Predicate
   * @generated
   */
  EClass getPredicate();

  /**
   * Returns the meta object for the attribute '{@link at.cl.atp.fOResolution.Predicate#getName <em>Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name</em>'.
   * @see at.cl.atp.fOResolution.Predicate#getName()
   * @see #getPredicate()
   * @generated
   */
  EAttribute getPredicate_Name();

  /**
   * Returns the meta object for the containment reference list '{@link at.cl.atp.fOResolution.Predicate#getArguments <em>Arguments</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Arguments</em>'.
   * @see at.cl.atp.fOResolution.Predicate#getArguments()
   * @see #getPredicate()
   * @generated
   */
  EReference getPredicate_Arguments();

  /**
   * Returns the meta object for class '{@link at.cl.atp.fOResolution.Function <em>Function</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Function</em>'.
   * @see at.cl.atp.fOResolution.Function
   * @generated
   */
  EClass getFunction();

  /**
   * Returns the meta object for the attribute '{@link at.cl.atp.fOResolution.Function#getName <em>Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name</em>'.
   * @see at.cl.atp.fOResolution.Function#getName()
   * @see #getFunction()
   * @generated
   */
  EAttribute getFunction_Name();

  /**
   * Returns the meta object for the containment reference list '{@link at.cl.atp.fOResolution.Function#getArguments <em>Arguments</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Arguments</em>'.
   * @see at.cl.atp.fOResolution.Function#getArguments()
   * @see #getFunction()
   * @generated
   */
  EReference getFunction_Arguments();

  /**
   * Returns the meta object for class '{@link at.cl.atp.fOResolution.Atom <em>Atom</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Atom</em>'.
   * @see at.cl.atp.fOResolution.Atom
   * @generated
   */
  EClass getAtom();

  /**
   * Returns the meta object for the attribute '{@link at.cl.atp.fOResolution.Atom#getName <em>Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name</em>'.
   * @see at.cl.atp.fOResolution.Atom#getName()
   * @see #getAtom()
   * @generated
   */
  EAttribute getAtom_Name();

  /**
   * Returns the meta object for class '{@link at.cl.atp.fOResolution.Variable <em>Variable</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Variable</em>'.
   * @see at.cl.atp.fOResolution.Variable
   * @generated
   */
  EClass getVariable();

  /**
   * Returns the meta object for class '{@link at.cl.atp.fOResolution.Constant <em>Constant</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Constant</em>'.
   * @see at.cl.atp.fOResolution.Constant
   * @generated
   */
  EClass getConstant();

  /**
   * Returns the meta object for class '{@link at.cl.atp.fOResolution.LowBindFormula <em>Low Bind Formula</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Low Bind Formula</em>'.
   * @see at.cl.atp.fOResolution.LowBindFormula
   * @generated
   */
  EClass getLowBindFormula();

  /**
   * Returns the meta object for the containment reference '{@link at.cl.atp.fOResolution.LowBindFormula#getLeft <em>Left</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Left</em>'.
   * @see at.cl.atp.fOResolution.LowBindFormula#getLeft()
   * @see #getLowBindFormula()
   * @generated
   */
  EReference getLowBindFormula_Left();

  /**
   * Returns the meta object for the attribute '{@link at.cl.atp.fOResolution.LowBindFormula#getOperation <em>Operation</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Operation</em>'.
   * @see at.cl.atp.fOResolution.LowBindFormula#getOperation()
   * @see #getLowBindFormula()
   * @generated
   */
  EAttribute getLowBindFormula_Operation();

  /**
   * Returns the meta object for the containment reference '{@link at.cl.atp.fOResolution.LowBindFormula#getRight <em>Right</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Right</em>'.
   * @see at.cl.atp.fOResolution.LowBindFormula#getRight()
   * @see #getLowBindFormula()
   * @generated
   */
  EReference getLowBindFormula_Right();

  /**
   * Returns the meta object for enum '{@link at.cl.atp.fOResolution.BinaryOperation <em>Binary Operation</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for enum '<em>Binary Operation</em>'.
   * @see at.cl.atp.fOResolution.BinaryOperation
   * @generated
   */
  EEnum getBinaryOperation();

  /**
   * Returns the meta object for enum '{@link at.cl.atp.fOResolution.Quantifier <em>Quantifier</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for enum '<em>Quantifier</em>'.
   * @see at.cl.atp.fOResolution.Quantifier
   * @generated
   */
  EEnum getQuantifier();

  /**
   * Returns the factory that creates the instances of the model.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the factory that creates the instances of the model.
   * @generated
   */
  FOResolutionFactory getFOResolutionFactory();

  /**
   * <!-- begin-user-doc -->
   * Defines literals for the meta objects that represent
   * <ul>
   *   <li>each class,</li>
   *   <li>each feature of each class,</li>
   *   <li>each enum,</li>
   *   <li>and each data type</li>
   * </ul>
   * <!-- end-user-doc -->
   * @generated
   */
  interface Literals
  {
    /**
     * The meta object literal for the '{@link at.cl.atp.fOResolution.impl.FormulaImpl <em>Formula</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see at.cl.atp.fOResolution.impl.FormulaImpl
     * @see at.cl.atp.fOResolution.impl.FOResolutionPackageImpl#getFormula()
     * @generated
     */
    EClass FORMULA = eINSTANCE.getFormula();

    /**
     * The meta object literal for the '{@link at.cl.atp.fOResolution.impl.QuantifiedFormulaImpl <em>Quantified Formula</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see at.cl.atp.fOResolution.impl.QuantifiedFormulaImpl
     * @see at.cl.atp.fOResolution.impl.FOResolutionPackageImpl#getQuantifiedFormula()
     * @generated
     */
    EClass QUANTIFIED_FORMULA = eINSTANCE.getQuantifiedFormula();

    /**
     * The meta object literal for the '<em><b>Quantifier</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute QUANTIFIED_FORMULA__QUANTIFIER = eINSTANCE.getQuantifiedFormula_Quantifier();

    /**
     * The meta object literal for the '<em><b>Variables</b></em>' attribute list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute QUANTIFIED_FORMULA__VARIABLES = eINSTANCE.getQuantifiedFormula_Variables();

    /**
     * The meta object literal for the '<em><b>Inner Formula</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference QUANTIFIED_FORMULA__INNER_FORMULA = eINSTANCE.getQuantifiedFormula_InnerFormula();

    /**
     * The meta object literal for the '{@link at.cl.atp.fOResolution.impl.NegatedFormulaImpl <em>Negated Formula</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see at.cl.atp.fOResolution.impl.NegatedFormulaImpl
     * @see at.cl.atp.fOResolution.impl.FOResolutionPackageImpl#getNegatedFormula()
     * @generated
     */
    EClass NEGATED_FORMULA = eINSTANCE.getNegatedFormula();

    /**
     * The meta object literal for the '<em><b>Inner Formula</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference NEGATED_FORMULA__INNER_FORMULA = eINSTANCE.getNegatedFormula_InnerFormula();

    /**
     * The meta object literal for the '{@link at.cl.atp.fOResolution.impl.PredicateImpl <em>Predicate</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see at.cl.atp.fOResolution.impl.PredicateImpl
     * @see at.cl.atp.fOResolution.impl.FOResolutionPackageImpl#getPredicate()
     * @generated
     */
    EClass PREDICATE = eINSTANCE.getPredicate();

    /**
     * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute PREDICATE__NAME = eINSTANCE.getPredicate_Name();

    /**
     * The meta object literal for the '<em><b>Arguments</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference PREDICATE__ARGUMENTS = eINSTANCE.getPredicate_Arguments();

    /**
     * The meta object literal for the '{@link at.cl.atp.fOResolution.impl.FunctionImpl <em>Function</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see at.cl.atp.fOResolution.impl.FunctionImpl
     * @see at.cl.atp.fOResolution.impl.FOResolutionPackageImpl#getFunction()
     * @generated
     */
    EClass FUNCTION = eINSTANCE.getFunction();

    /**
     * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute FUNCTION__NAME = eINSTANCE.getFunction_Name();

    /**
     * The meta object literal for the '<em><b>Arguments</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference FUNCTION__ARGUMENTS = eINSTANCE.getFunction_Arguments();

    /**
     * The meta object literal for the '{@link at.cl.atp.fOResolution.impl.AtomImpl <em>Atom</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see at.cl.atp.fOResolution.impl.AtomImpl
     * @see at.cl.atp.fOResolution.impl.FOResolutionPackageImpl#getAtom()
     * @generated
     */
    EClass ATOM = eINSTANCE.getAtom();

    /**
     * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute ATOM__NAME = eINSTANCE.getAtom_Name();

    /**
     * The meta object literal for the '{@link at.cl.atp.fOResolution.impl.VariableImpl <em>Variable</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see at.cl.atp.fOResolution.impl.VariableImpl
     * @see at.cl.atp.fOResolution.impl.FOResolutionPackageImpl#getVariable()
     * @generated
     */
    EClass VARIABLE = eINSTANCE.getVariable();

    /**
     * The meta object literal for the '{@link at.cl.atp.fOResolution.impl.ConstantImpl <em>Constant</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see at.cl.atp.fOResolution.impl.ConstantImpl
     * @see at.cl.atp.fOResolution.impl.FOResolutionPackageImpl#getConstant()
     * @generated
     */
    EClass CONSTANT = eINSTANCE.getConstant();

    /**
     * The meta object literal for the '{@link at.cl.atp.fOResolution.impl.LowBindFormulaImpl <em>Low Bind Formula</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see at.cl.atp.fOResolution.impl.LowBindFormulaImpl
     * @see at.cl.atp.fOResolution.impl.FOResolutionPackageImpl#getLowBindFormula()
     * @generated
     */
    EClass LOW_BIND_FORMULA = eINSTANCE.getLowBindFormula();

    /**
     * The meta object literal for the '<em><b>Left</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference LOW_BIND_FORMULA__LEFT = eINSTANCE.getLowBindFormula_Left();

    /**
     * The meta object literal for the '<em><b>Operation</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute LOW_BIND_FORMULA__OPERATION = eINSTANCE.getLowBindFormula_Operation();

    /**
     * The meta object literal for the '<em><b>Right</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference LOW_BIND_FORMULA__RIGHT = eINSTANCE.getLowBindFormula_Right();

    /**
     * The meta object literal for the '{@link at.cl.atp.fOResolution.BinaryOperation <em>Binary Operation</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see at.cl.atp.fOResolution.BinaryOperation
     * @see at.cl.atp.fOResolution.impl.FOResolutionPackageImpl#getBinaryOperation()
     * @generated
     */
    EEnum BINARY_OPERATION = eINSTANCE.getBinaryOperation();

    /**
     * The meta object literal for the '{@link at.cl.atp.fOResolution.Quantifier <em>Quantifier</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see at.cl.atp.fOResolution.Quantifier
     * @see at.cl.atp.fOResolution.impl.FOResolutionPackageImpl#getQuantifier()
     * @generated
     */
    EEnum QUANTIFIER = eINSTANCE.getQuantifier();

  }

} //FOResolutionPackage
