package at.cl.atp.validation;

import at.cl.atp.fOResolution.Formula;
import org.eclipse.xtend.lib.Data;
import org.eclipse.xtext.xbase.lib.util.ToStringHelper;

@Data
@SuppressWarnings("all")
public class VariableRebinding {
  private final Formula _binder;
  
  public Formula getBinder() {
    return this._binder;
  }
  
  private final String _variable;
  
  public String getVariable() {
    return this._variable;
  }
  
  public VariableRebinding(final Formula binder, final String variable) {
    super();
    this._binder = binder;
    this._variable = variable;
  }
  
  @Override
  public int hashCode() {
    final int prime = 31;
    int result = 1;
    result = prime * result + ((_binder== null) ? 0 : _binder.hashCode());
    result = prime * result + ((_variable== null) ? 0 : _variable.hashCode());
    return result;
  }
  
  @Override
  public boolean equals(final Object obj) {
    if (this == obj)
      return true;
    if (obj == null)
      return false;
    if (getClass() != obj.getClass())
      return false;
    VariableRebinding other = (VariableRebinding) obj;
    if (_binder == null) {
      if (other._binder != null)
        return false;
    } else if (!_binder.equals(other._binder))
      return false;
    if (_variable == null) {
      if (other._variable != null)
        return false;
    } else if (!_variable.equals(other._variable))
      return false;
    return true;
  }
  
  @Override
  public String toString() {
    String result = new ToStringHelper().toString(this);
    return result;
  }
}
