package at.cl.atp.foresolution.alphabet;

public interface Alphabet {

	public char getUnicodeLower(final int characterIndex);

	public char getUnicodeUpper(final int characterIndex);

	public String getLatexLower(final int characterIndex, final boolean includeBackslash);

	public String getLatexUpper(final int characterIndex, final boolean includeBackslash);

	public int getIndex(final char unicodeCharacter);

	public int getIndex(final String latexCharacter);

	public char toUpper(final char unicodeCharacter);

	public char toLower(final char unicodeCharacter);

	public String toUpper(final String latexCharacter);

	public String toLower(final String latexCharacter);

	public String toLatex(final char unicodeCharacter);

	public char toUnicode(final String latexCharacter);

	public int getAlphabetSize();

	public boolean contains(final char unicodeCharacter);

	public boolean isUppercase(final char unicodeCharacter);

	public boolean isLowercase(final char unicodeCharacter);
}
