package at.cl.atp.foresolution.exceptions;

import at.cl.atp.fOResolution.Formula;
import at.cl.atp.foresolution.util.FormulaFormatter;

public class NotUnifiableException extends RuntimeException {

	private static final long serialVersionUID = 1L;

	private final String message;

	public NotUnifiableException(final Formula left, final Formula right) {
		StringBuilder builder = new StringBuilder();
		builder.append("The formula ");
		builder.append(FormulaFormatter.format(left));
		builder.append(" is not unifiable with ");
		builder.append(FormulaFormatter.format(right));
		this.message = builder.toString();
	}

	@Override
	public String getMessage() {
		return this.message;
	}

}
