package at.cl.atp.foresolution.main;

import static org.junit.Assert.assertEquals;

import java.util.Scanner;

import util.TestHelper;
import at.cl.atp.foresolution.prover.ResolutionOutput;
import at.cl.atp.foresolution.prover.ResolutionResult;
import at.cl.atp.foresolution.settings.Settings;

public class TestMain {

	/**
	 * @param args
	 */
	public static void main(final String[] args) {
		Settings.setTemporaryProperty(Settings.SETTING_NEGATE_INPUT, false);
		Settings.setTemporaryProperty(Settings.SETTING_NO_RENAME, true);
		try {
			Scanner scanner = new Scanner(System.in);
			scanner.nextLine();
			ResolutionOutput result = TestHelper.executeResolution("agatha.tptp");
			System.out.println();
			System.out.println();
			assertEquals("TPTP Agatha test failed!", ResolutionResult.BOX, result.getResult());
		} finally {
			Settings.setTemporaryProperty(Settings.SETTING_NEGATE_INPUT, true);
			Settings.setTemporaryProperty(Settings.SETTING_NO_RENAME, false);
		}
	}

}
