package at.cl.atp.foresolution.model.clause;

import java.util.Collection;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;

public class ClausalForm {

	private final Set<Clause> clauses;

	public ClausalForm() {
		this.clauses = new HashSet<Clause>();
	}

	public Iterator<Clause> clauseIterator() {
		return this.clauses.iterator();
	}

	public Set<Clause> getClauses() {
		return this.clauses;
	}

	public void add(final Clause clause) {
		this.clauses.add(clause);
	}

	public void addAll(final Collection<? extends Clause> clauses) {
		this.clauses.addAll(clauses);
	}

	public boolean isEmpty() {
		return this.clauses.isEmpty();
	}

	public int size() {
		return this.clauses.size();
	}

	@Override
	public String toString() {
		StringBuilder builder = new StringBuilder();
		builder.append("{ ");
		for (Clause clause : this.clauses) {
			builder.append(clause.toString());
			builder.append(" ");
		}
		builder.append("}");
		return builder.toString();
	}

}
