package at.cl.atp.foresolution.model.clause;

import java.util.Collection;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;

public class ImmutableSet<T> implements Set<T> {

	private final HashSet<T> content;

	public ImmutableSet(final Collection<T> contents) {
		this.content = new HashSet<T>();
		this.content.addAll(contents);
	}

	@Override
	public boolean add(final T e) {
		throw new UnsupportedOperationException("Cannot perform ADD on immutable set!");
	}

	@Override
	public boolean addAll(final Collection<? extends T> c) {
		throw new UnsupportedOperationException("Cannot perform ADDALL on immutable set!");
	}

	@Override
	public void clear() {
		throw new UnsupportedOperationException("Cannot perform CLEAR on immutable set!");
	}

	@Override
	public boolean contains(final Object o) {
		return this.content.contains(o);
	}

	@Override
	public boolean containsAll(final Collection<?> c) {
		return this.content.containsAll(c);
	}

	@Override
	public boolean isEmpty() {
		return this.content.isEmpty();
	}

	@Override
	public Iterator<T> iterator() {
		return this.content.iterator();
	}

	@Override
	public boolean remove(final Object o) {
		throw new UnsupportedOperationException("Cannot perform REMOVE on immutable set!");
	}

	@Override
	public boolean removeAll(final Collection<?> c) {
		throw new UnsupportedOperationException("Cannot perform REMOVEALL on immutable set!");
	}

	@Override
	public boolean retainAll(final Collection<?> c) {
		throw new UnsupportedOperationException("Cannot perform RETAINALL on immutable set!");
	}

	@Override
	public int size() {
		return this.content.size();
	}

	@Override
	public Object[] toArray() {
		return this.content.toArray();
	}

	@Override
	public <A> A[] toArray(final A[] a) {
		return this.content.toArray(a);
	}
}
