package at.cl.atp.foresolution.prover;

import at.cl.atp.foresolution.model.clause.Clause;
import at.cl.atp.foresolution.transformations.substitution.Substitution;

public class ResolutionOutput {

	public static ResolutionOutput createBox(final Clause leftParentOfBox, final Clause rightParentOfBox,
			final Substitution mgu) {
		return new ResolutionOutput(ResolutionResult.BOX, leftParentOfBox, rightParentOfBox, mgu);
	}

	public static ResolutionOutput createEmptySet() {
		return new ResolutionOutput(ResolutionResult.EMPTY_SET, null, null, null);
	}

	public static ResolutionOutput createNoContradiction() {
		return new ResolutionOutput(ResolutionResult.NO_CONTRADICTION, null, null, null);
	}

	private final ResolutionResult result;
	private final Clause leftParentOfBox;
	private final Clause rightParentOfBox;
	private final Substitution mgu;

	private ResolutionOutput(final ResolutionResult result, final Clause leftParentOfBox,
			final Clause rightParentOfBox, final Substitution mgu) {
		this.result = result;
		this.leftParentOfBox = leftParentOfBox;
		this.rightParentOfBox = rightParentOfBox;
		this.mgu = mgu;
	}

	public ResolutionResult getResult() {
		return this.result;
	}

	public Clause getLeftParentOfBox() {
		return this.leftParentOfBox;
	}

	public Clause getRightParentOfBox() {
		return this.rightParentOfBox;
	}

	public Substitution getMgu() {
		return this.mgu;
	}

}
