package at.cl.atp.foresolution.util;

import java.util.Iterator;
import java.util.Stack;

import at.cl.atp.foresolution.model.clause.Clause;

public class ClausePostfixIterator implements Iterator<String> {

	private Stack<Clause> nodeStack = new Stack<Clause>();
	private Clause previousNode = null;

	public ClausePostfixIterator(final Clause root) {
		this.nodeStack.push(root);
	}

	@Override
	public boolean hasNext() {
		return this.nodeStack.isEmpty() == false;
	}

	@Override
	public String next() {
		Clause currentNode = this.nodeStack.peek();
		while (!this.nodeStack.isEmpty()) {
			if (this.previousNode == null || this.previousNode.getLeftParent() == currentNode
					|| this.previousNode.getRightParent() == currentNode) {
				if (currentNode.getLeftParent() != null) {
					this.nodeStack.push(currentNode.getLeftParent());
				} else if (currentNode.getRightParent() != null) {
					this.nodeStack.push(currentNode.getRightParent());
				}
				this.previousNode = currentNode;
			} else if (currentNode.getLeftParent() == this.previousNode) {
				if (currentNode.getRightParent() != null) {
					this.nodeStack.push(currentNode.getRightParent());
				}
				this.previousNode = currentNode;
			} else {
				this.nodeStack.pop();
				// return FormulaFormatter.formatForLatex(currentNode);
				return "todo";
			}
		}
		throw new RuntimeException("This is impossible to reach!");
	}

	@Override
	public void remove() {
		throw new UnsupportedOperationException();
	}

}
