package at.cl.atp.foresolution.util;

import java.util.Comparator;

import at.cl.atp.foresolution.model.clause.ClauseLiteral;

public class VariablesInLiteralComparator implements Comparator<ClauseLiteral> {

	@Override
	public int compare(final ClauseLiteral first, final ClauseLiteral second) {
		int varsInFirst = first.getVariableOccurrenceCount();
		int varsInSecond = second.getVariableOccurrenceCount();
		if (varsInFirst < varsInSecond) {
			return 1;
		} else if (varsInFirst > varsInSecond) {
			return -1;
		} else {
			int distinctVarsInFirst = first.getVariables().size();
			int distinctVarsInSecond = second.getVariables().size();
			if (distinctVarsInFirst < distinctVarsInSecond) {
				return 1;
			} else if (distinctVarsInFirst > distinctVarsInSecond) {
				return -1;
			} else {
				return 0;
			}
		}
	}

}
