package at.cl.atp.foresolution.exceptions;

import at.cl.atp.fOResolution.Formula;
import at.cl.atp.foresolution.transformations.substitution.Substitution;
import at.cl.atp.foresolution.util.FormulaFormatter;

public class NonFreeSubstitutionException extends RuntimeException {

	private static final long serialVersionUID = 1L;

	private String message;

	public NonFreeSubstitutionException(final Formula formula, final Substitution substitution) {
		StringBuilder builder = new StringBuilder();
		builder.append("The formula ");
		builder.append(FormulaFormatter.format(formula));
		builder.append(" is not free for the substitution ");
		builder.append(substitution.toString());
		this.message = builder.toString();
	}

	@Override
	public String getMessage() {
		return this.message;
	}

}
