package at.cl.atp.foresolution.exceptions;

import at.cl.atp.fOResolution.Formula;
import at.cl.atp.foresolution.util.FormulaFormatter;

public class ReplacementOverrideException extends RuntimeException {

	private static final long serialVersionUID = 1L;

	private String message;

	public ReplacementOverrideException(final String variable, final Formula formula, final Formula target) {
		StringBuilder builder = new StringBuilder();
		builder.append("There is already a mapping for variable \"");
		builder.append(variable);
		builder.append("\" referring to ");
		builder.append(FormulaFormatter.format(formula));
		builder.append(", cannot remap to ");
		builder.append(FormulaFormatter.format(target));
		this.message = builder.toString();
	}

	@Override
	public String getMessage() {
		return this.message;
	}

}
