package at.cl.atp.foresolution.model.container;

public class SkolemNameProvider {

	private long variableIndex = 0;
	private long functionIndex = 0;
	private long predicateIndex = 0;

	private final String variableBase;
	private final String functionBase;
	private final String predicateBase;

	public SkolemNameProvider(final String variableBase, final String functionBase, final String predicateBase) {
		this.variableBase = variableBase;
		this.functionBase = functionBase;
		this.predicateBase = predicateBase;
	}

	public SkolemNameProvider() {
		this("v", "f", "P");
	}

	public String nextSkolemVariable() {
		String name = "_" + this.variableBase + this.variableIndex;
		this.variableIndex++;
		return name;
	}

	public String nextSkolemFunction() {
		String name = "_" + this.functionBase + this.functionIndex;
		this.functionIndex++;
		return name;
	}

	public String nextSkolemPredicate() {
		String name = "_" + this.predicateBase + this.predicateIndex;
		this.predicateIndex++;
		return name;
	}
}
