package factorization;

import java.util.Set;

import org.junit.AfterClass;
import org.junit.BeforeClass;
import org.junit.Ignore;
import org.junit.Test;

import util.TestHelper;
import at.cl.atp.fOResolution.Formula;
import at.cl.atp.foresolution.model.clause.ClausalForm;
import at.cl.atp.foresolution.model.clause.ClausalFormBuilder;
import at.cl.atp.foresolution.model.clause.Clause;
import at.cl.atp.foresolution.model.container.FormulaContainer;
import at.cl.atp.foresolution.settings.Settings;

public class FactorizationTest {

	@BeforeClass
	public static void buildUp() {
		Settings.setTemporaryProperty(Settings.SETTING_NEGATE_INPUT, false);
		Settings.setTemporaryProperty(Settings.SETTING_NO_RENAME, true);
	}

	@AfterClass
	public static void tearDown() {
		Settings.clearTemporarySettings();
	}

	@Ignore
	@Test
	public void factorizationTest() {
		Formula formula = TestHelper.load("factorsTest");
		ClausalForm clausalForm = ClausalFormBuilder.build(new FormulaContainer(formula));
		Clause clause = clausalForm.getClauses().iterator().next();
		System.out.println(clause.toString());
		Set<Clause> factors = clause.factorize();
		System.out.println(factors.toString());
	}
}
