package hashing;

import static org.junit.Assert.assertEquals;

import org.junit.Test;

import util.TestHelper;
import at.cl.atp.fOResolution.Formula;
import at.cl.atp.foresolution.model.clause.Clause;
import at.cl.atp.foresolution.model.clause.ClauseLiteral;

public class HashingTest {

	@Test
	public void hashConsistencyTest() {
		Formula left = TestHelper.load("hashingTest01_left");
		Formula right = TestHelper.load("hashingTest01_right");
		Clause clauseLeft = Clause.createUnitClause(new ClauseLiteral(left));
		Clause clauseRight = Clause.createUnitClause(new ClauseLiteral(right));
		int hash1 = clauseLeft.hashCode();
		int hash2 = clauseLeft.duplicate().hashCode();
		System.out.println("Left: " + clauseLeft.toString());
		System.out.println("Right: " + clauseRight.toString());
		System.out.println("Hash1: " + hash1);
		System.out.println("Hash2: " + hash2);

		assertEquals(hash1, hash2);
	}
}
