package substitution;

import static org.junit.Assert.assertTrue;

import org.eclipse.emf.ecore.util.EcoreUtil;
import org.junit.Test;

import util.TestHelper;
import at.cl.atp.fOResolution.Formula;
import at.cl.atp.foresolution.transformations.substitution.Substitution;
import at.cl.atp.foresolution.transformations.substitution.mgu.Unification;
import at.cl.atp.foresolution.util.FormulaFormatter;

public class SubstitutionTest {

	@Test
	public void substitutionTest01() {
		Formula left = TestHelper.load("substitutionTest01_left");
		Formula right = TestHelper.load("substitutionTest01_right");
		String leftToString = FormulaFormatter.format(left);
		String rightToString = FormulaFormatter.format(right);
		System.out.println(leftToString);
		System.out.println(rightToString);
		Substitution mgu = Unification.createMGU(left, right);
		assertTrue(mgu != null);
		System.out.println(mgu.toString());
		assertTrue(leftToString.contentEquals(FormulaFormatter.format(left)));
		assertTrue(rightToString.contentEquals(FormulaFormatter.format(right)));
		Formula left2 = EcoreUtil.copy(left);
		Formula right2 = EcoreUtil.copy(right);
		assertTrue(leftToString.contentEquals(FormulaFormatter.format(left2)));
		assertTrue(rightToString.contentEquals(FormulaFormatter.format(right2)));
		Formula left3 = mgu.applyTo(left2);
		Formula right3 = mgu.applyTo(right2);
		String left3ToString = FormulaFormatter.format(left3);
		String right3ToString = FormulaFormatter.format(right3);
		System.out.println(left3ToString);
		System.out.println(right3ToString);
		assertTrue(left3ToString.contentEquals(right3ToString));
		assertTrue(leftToString.contentEquals(FormulaFormatter.format(left)));
		assertTrue(rightToString.contentEquals(FormulaFormatter.format(right)));
		System.out.println(FormulaFormatter.format(left));
		System.out.println(FormulaFormatter.format(right));
	}
}
