package subsumption;

import static org.junit.Assert.assertTrue;

import org.junit.Test;

import util.TestHelper;
import at.cl.atp.fOResolution.Formula;
import at.cl.atp.foresolution.model.clause.ClausalForm;
import at.cl.atp.foresolution.model.clause.ClausalFormBuilder;
import at.cl.atp.foresolution.model.clause.Clause;
import at.cl.atp.foresolution.model.container.FormulaContainer;

public class SubsumptionTest {

	@Test
	public void subsumptionTest01() {
		Formula left = TestHelper.load("subsumptionTest01_a");
		Formula right = TestHelper.load("subsumptionTest01_b");
		FormulaContainer container1 = new FormulaContainer(left);
		FormulaContainer container2 = new FormulaContainer(right);
		ClausalForm clausalForm1 = ClausalFormBuilder.build(container1);
		ClausalForm clausalForm2 = ClausalFormBuilder.build(container2);
		Clause c = clausalForm1.getClauses().iterator().next();
		Clause d = clausalForm2.getClauses().iterator().next();
		System.out.println("C: " + c.toString());
		System.out.println("D: " + d.toString());
		boolean cSubD = c.subsumes(d);
		assertTrue(cSubD == false);
		System.out.println("C does not subsume D.");
	}

	@Test
	public void subsumptionTest02() {
		Formula left = TestHelper.load("subsumptionTest02_a");
		Formula right = TestHelper.load("subsumptionTest02_b");
		FormulaContainer container1 = new FormulaContainer(left);
		FormulaContainer container2 = new FormulaContainer(right);
		ClausalForm clausalForm1 = ClausalFormBuilder.build(container1);
		ClausalForm clausalForm2 = ClausalFormBuilder.build(container2);
		Clause c = clausalForm1.getClauses().iterator().next();
		Clause d = clausalForm2.getClauses().iterator().next();
		System.out.println("C: " + c.toString());
		System.out.println("D: " + d.toString());
		boolean cSubD = c.subsumes(d);
		assertTrue(cSubD);
		System.out.println("C does subsume D.");
	}

}
