/**
 */
package at.cl.atp.resolution;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see at.cl.atp.resolution.ResolutionFactory
 * @model kind="package"
 * @generated
 */
public interface ResolutionPackage extends EPackage
{
  /**
   * The package name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNAME = "resolution";

  /**
   * The package namespace URI.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_URI = "http://www.cl.at/atp/Resolution";

  /**
   * The package namespace name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_PREFIX = "resolution";

  /**
   * The singleton instance of the package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  ResolutionPackage eINSTANCE = at.cl.atp.resolution.impl.ResolutionPackageImpl.init();

  /**
   * The meta object id for the '{@link at.cl.atp.resolution.impl.ResolutionProblemImpl <em>Problem</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see at.cl.atp.resolution.impl.ResolutionProblemImpl
   * @see at.cl.atp.resolution.impl.ResolutionPackageImpl#getResolutionProblem()
   * @generated
   */
  int RESOLUTION_PROBLEM = 0;

  /**
   * The feature id for the '<em><b>Formulas</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int RESOLUTION_PROBLEM__FORMULAS = 0;

  /**
   * The number of structural features of the '<em>Problem</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int RESOLUTION_PROBLEM_FEATURE_COUNT = 1;

  /**
   * The meta object id for the '{@link at.cl.atp.resolution.impl.FormulaImpl <em>Formula</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see at.cl.atp.resolution.impl.FormulaImpl
   * @see at.cl.atp.resolution.impl.ResolutionPackageImpl#getFormula()
   * @generated
   */
  int FORMULA = 1;

  /**
   * The number of structural features of the '<em>Formula</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FORMULA_FEATURE_COUNT = 0;

  /**
   * The meta object id for the '{@link at.cl.atp.resolution.impl.AtomImpl <em>Atom</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see at.cl.atp.resolution.impl.AtomImpl
   * @see at.cl.atp.resolution.impl.ResolutionPackageImpl#getAtom()
   * @generated
   */
  int ATOM = 2;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ATOM__NAME = FORMULA_FEATURE_COUNT + 0;

  /**
   * The number of structural features of the '<em>Atom</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ATOM_FEATURE_COUNT = FORMULA_FEATURE_COUNT + 1;

  /**
   * The meta object id for the '{@link at.cl.atp.resolution.impl.NegatedFormulaImpl <em>Negated Formula</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see at.cl.atp.resolution.impl.NegatedFormulaImpl
   * @see at.cl.atp.resolution.impl.ResolutionPackageImpl#getNegatedFormula()
   * @generated
   */
  int NEGATED_FORMULA = 3;

  /**
   * The feature id for the '<em><b>Inner Formula</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int NEGATED_FORMULA__INNER_FORMULA = FORMULA_FEATURE_COUNT + 0;

  /**
   * The number of structural features of the '<em>Negated Formula</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int NEGATED_FORMULA_FEATURE_COUNT = FORMULA_FEATURE_COUNT + 1;

  /**
   * The meta object id for the '{@link at.cl.atp.resolution.impl.ConjunctiveFormulaImpl <em>Conjunctive Formula</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see at.cl.atp.resolution.impl.ConjunctiveFormulaImpl
   * @see at.cl.atp.resolution.impl.ResolutionPackageImpl#getConjunctiveFormula()
   * @generated
   */
  int CONJUNCTIVE_FORMULA = 4;

  /**
   * The feature id for the '<em><b>First</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONJUNCTIVE_FORMULA__FIRST = FORMULA_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Second</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONJUNCTIVE_FORMULA__SECOND = FORMULA_FEATURE_COUNT + 1;

  /**
   * The number of structural features of the '<em>Conjunctive Formula</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONJUNCTIVE_FORMULA_FEATURE_COUNT = FORMULA_FEATURE_COUNT + 2;

  /**
   * The meta object id for the '{@link at.cl.atp.resolution.impl.AndFormulaImpl <em>And Formula</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see at.cl.atp.resolution.impl.AndFormulaImpl
   * @see at.cl.atp.resolution.impl.ResolutionPackageImpl#getAndFormula()
   * @generated
   */
  int AND_FORMULA = 5;

  /**
   * The feature id for the '<em><b>First</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int AND_FORMULA__FIRST = CONJUNCTIVE_FORMULA__FIRST;

  /**
   * The feature id for the '<em><b>Second</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int AND_FORMULA__SECOND = CONJUNCTIVE_FORMULA__SECOND;

  /**
   * The number of structural features of the '<em>And Formula</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int AND_FORMULA_FEATURE_COUNT = CONJUNCTIVE_FORMULA_FEATURE_COUNT + 0;

  /**
   * The meta object id for the '{@link at.cl.atp.resolution.impl.OrFormulaImpl <em>Or Formula</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see at.cl.atp.resolution.impl.OrFormulaImpl
   * @see at.cl.atp.resolution.impl.ResolutionPackageImpl#getOrFormula()
   * @generated
   */
  int OR_FORMULA = 6;

  /**
   * The feature id for the '<em><b>First</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int OR_FORMULA__FIRST = CONJUNCTIVE_FORMULA__FIRST;

  /**
   * The feature id for the '<em><b>Second</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int OR_FORMULA__SECOND = CONJUNCTIVE_FORMULA__SECOND;

  /**
   * The number of structural features of the '<em>Or Formula</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int OR_FORMULA_FEATURE_COUNT = CONJUNCTIVE_FORMULA_FEATURE_COUNT + 0;

  /**
   * The meta object id for the '{@link at.cl.atp.resolution.impl.ImplicationFormulaImpl <em>Implication Formula</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see at.cl.atp.resolution.impl.ImplicationFormulaImpl
   * @see at.cl.atp.resolution.impl.ResolutionPackageImpl#getImplicationFormula()
   * @generated
   */
  int IMPLICATION_FORMULA = 7;

  /**
   * The feature id for the '<em><b>First</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IMPLICATION_FORMULA__FIRST = CONJUNCTIVE_FORMULA__FIRST;

  /**
   * The feature id for the '<em><b>Second</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IMPLICATION_FORMULA__SECOND = CONJUNCTIVE_FORMULA__SECOND;

  /**
   * The number of structural features of the '<em>Implication Formula</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IMPLICATION_FORMULA_FEATURE_COUNT = CONJUNCTIVE_FORMULA_FEATURE_COUNT + 0;


  /**
   * Returns the meta object for class '{@link at.cl.atp.resolution.ResolutionProblem <em>Problem</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Problem</em>'.
   * @see at.cl.atp.resolution.ResolutionProblem
   * @generated
   */
  EClass getResolutionProblem();

  /**
   * Returns the meta object for the containment reference list '{@link at.cl.atp.resolution.ResolutionProblem#getFormulas <em>Formulas</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Formulas</em>'.
   * @see at.cl.atp.resolution.ResolutionProblem#getFormulas()
   * @see #getResolutionProblem()
   * @generated
   */
  EReference getResolutionProblem_Formulas();

  /**
   * Returns the meta object for class '{@link at.cl.atp.resolution.Formula <em>Formula</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Formula</em>'.
   * @see at.cl.atp.resolution.Formula
   * @generated
   */
  EClass getFormula();

  /**
   * Returns the meta object for class '{@link at.cl.atp.resolution.Atom <em>Atom</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Atom</em>'.
   * @see at.cl.atp.resolution.Atom
   * @generated
   */
  EClass getAtom();

  /**
   * Returns the meta object for the attribute '{@link at.cl.atp.resolution.Atom#getName <em>Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name</em>'.
   * @see at.cl.atp.resolution.Atom#getName()
   * @see #getAtom()
   * @generated
   */
  EAttribute getAtom_Name();

  /**
   * Returns the meta object for class '{@link at.cl.atp.resolution.NegatedFormula <em>Negated Formula</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Negated Formula</em>'.
   * @see at.cl.atp.resolution.NegatedFormula
   * @generated
   */
  EClass getNegatedFormula();

  /**
   * Returns the meta object for the containment reference '{@link at.cl.atp.resolution.NegatedFormula#getInnerFormula <em>Inner Formula</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Inner Formula</em>'.
   * @see at.cl.atp.resolution.NegatedFormula#getInnerFormula()
   * @see #getNegatedFormula()
   * @generated
   */
  EReference getNegatedFormula_InnerFormula();

  /**
   * Returns the meta object for class '{@link at.cl.atp.resolution.ConjunctiveFormula <em>Conjunctive Formula</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Conjunctive Formula</em>'.
   * @see at.cl.atp.resolution.ConjunctiveFormula
   * @generated
   */
  EClass getConjunctiveFormula();

  /**
   * Returns the meta object for the containment reference '{@link at.cl.atp.resolution.ConjunctiveFormula#getFirst <em>First</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>First</em>'.
   * @see at.cl.atp.resolution.ConjunctiveFormula#getFirst()
   * @see #getConjunctiveFormula()
   * @generated
   */
  EReference getConjunctiveFormula_First();

  /**
   * Returns the meta object for the containment reference '{@link at.cl.atp.resolution.ConjunctiveFormula#getSecond <em>Second</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Second</em>'.
   * @see at.cl.atp.resolution.ConjunctiveFormula#getSecond()
   * @see #getConjunctiveFormula()
   * @generated
   */
  EReference getConjunctiveFormula_Second();

  /**
   * Returns the meta object for class '{@link at.cl.atp.resolution.AndFormula <em>And Formula</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>And Formula</em>'.
   * @see at.cl.atp.resolution.AndFormula
   * @generated
   */
  EClass getAndFormula();

  /**
   * Returns the meta object for class '{@link at.cl.atp.resolution.OrFormula <em>Or Formula</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Or Formula</em>'.
   * @see at.cl.atp.resolution.OrFormula
   * @generated
   */
  EClass getOrFormula();

  /**
   * Returns the meta object for class '{@link at.cl.atp.resolution.ImplicationFormula <em>Implication Formula</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Implication Formula</em>'.
   * @see at.cl.atp.resolution.ImplicationFormula
   * @generated
   */
  EClass getImplicationFormula();

  /**
   * Returns the factory that creates the instances of the model.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the factory that creates the instances of the model.
   * @generated
   */
  ResolutionFactory getResolutionFactory();

  /**
   * <!-- begin-user-doc -->
   * Defines literals for the meta objects that represent
   * <ul>
   *   <li>each class,</li>
   *   <li>each feature of each class,</li>
   *   <li>each enum,</li>
   *   <li>and each data type</li>
   * </ul>
   * <!-- end-user-doc -->
   * @generated
   */
  interface Literals
  {
    /**
     * The meta object literal for the '{@link at.cl.atp.resolution.impl.ResolutionProblemImpl <em>Problem</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see at.cl.atp.resolution.impl.ResolutionProblemImpl
     * @see at.cl.atp.resolution.impl.ResolutionPackageImpl#getResolutionProblem()
     * @generated
     */
    EClass RESOLUTION_PROBLEM = eINSTANCE.getResolutionProblem();

    /**
     * The meta object literal for the '<em><b>Formulas</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference RESOLUTION_PROBLEM__FORMULAS = eINSTANCE.getResolutionProblem_Formulas();

    /**
     * The meta object literal for the '{@link at.cl.atp.resolution.impl.FormulaImpl <em>Formula</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see at.cl.atp.resolution.impl.FormulaImpl
     * @see at.cl.atp.resolution.impl.ResolutionPackageImpl#getFormula()
     * @generated
     */
    EClass FORMULA = eINSTANCE.getFormula();

    /**
     * The meta object literal for the '{@link at.cl.atp.resolution.impl.AtomImpl <em>Atom</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see at.cl.atp.resolution.impl.AtomImpl
     * @see at.cl.atp.resolution.impl.ResolutionPackageImpl#getAtom()
     * @generated
     */
    EClass ATOM = eINSTANCE.getAtom();

    /**
     * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute ATOM__NAME = eINSTANCE.getAtom_Name();

    /**
     * The meta object literal for the '{@link at.cl.atp.resolution.impl.NegatedFormulaImpl <em>Negated Formula</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see at.cl.atp.resolution.impl.NegatedFormulaImpl
     * @see at.cl.atp.resolution.impl.ResolutionPackageImpl#getNegatedFormula()
     * @generated
     */
    EClass NEGATED_FORMULA = eINSTANCE.getNegatedFormula();

    /**
     * The meta object literal for the '<em><b>Inner Formula</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference NEGATED_FORMULA__INNER_FORMULA = eINSTANCE.getNegatedFormula_InnerFormula();

    /**
     * The meta object literal for the '{@link at.cl.atp.resolution.impl.ConjunctiveFormulaImpl <em>Conjunctive Formula</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see at.cl.atp.resolution.impl.ConjunctiveFormulaImpl
     * @see at.cl.atp.resolution.impl.ResolutionPackageImpl#getConjunctiveFormula()
     * @generated
     */
    EClass CONJUNCTIVE_FORMULA = eINSTANCE.getConjunctiveFormula();

    /**
     * The meta object literal for the '<em><b>First</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference CONJUNCTIVE_FORMULA__FIRST = eINSTANCE.getConjunctiveFormula_First();

    /**
     * The meta object literal for the '<em><b>Second</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference CONJUNCTIVE_FORMULA__SECOND = eINSTANCE.getConjunctiveFormula_Second();

    /**
     * The meta object literal for the '{@link at.cl.atp.resolution.impl.AndFormulaImpl <em>And Formula</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see at.cl.atp.resolution.impl.AndFormulaImpl
     * @see at.cl.atp.resolution.impl.ResolutionPackageImpl#getAndFormula()
     * @generated
     */
    EClass AND_FORMULA = eINSTANCE.getAndFormula();

    /**
     * The meta object literal for the '{@link at.cl.atp.resolution.impl.OrFormulaImpl <em>Or Formula</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see at.cl.atp.resolution.impl.OrFormulaImpl
     * @see at.cl.atp.resolution.impl.ResolutionPackageImpl#getOrFormula()
     * @generated
     */
    EClass OR_FORMULA = eINSTANCE.getOrFormula();

    /**
     * The meta object literal for the '{@link at.cl.atp.resolution.impl.ImplicationFormulaImpl <em>Implication Formula</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see at.cl.atp.resolution.impl.ImplicationFormulaImpl
     * @see at.cl.atp.resolution.impl.ResolutionPackageImpl#getImplicationFormula()
     * @generated
     */
    EClass IMPLICATION_FORMULA = eINSTANCE.getImplicationFormula();

  }

} //ResolutionPackage
