/**
 */
package at.cl.atp.resolution.util;

import at.cl.atp.resolution.*;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see at.cl.atp.resolution.ResolutionPackage
 * @generated
 */
public class ResolutionAdapterFactory extends AdapterFactoryImpl
{
  /**
   * The cached model package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected static ResolutionPackage modelPackage;

  /**
   * Creates an instance of the adapter factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ResolutionAdapterFactory()
  {
    if (modelPackage == null)
    {
      modelPackage = ResolutionPackage.eINSTANCE;
    }
  }

  /**
   * Returns whether this factory is applicable for the type of the object.
   * <!-- begin-user-doc -->
   * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
   * <!-- end-user-doc -->
   * @return whether this factory is applicable for the type of the object.
   * @generated
   */
  @Override
  public boolean isFactoryForType(Object object)
  {
    if (object == modelPackage)
    {
      return true;
    }
    if (object instanceof EObject)
    {
      return ((EObject)object).eClass().getEPackage() == modelPackage;
    }
    return false;
  }

  /**
   * The switch that delegates to the <code>createXXX</code> methods.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ResolutionSwitch<Adapter> modelSwitch =
    new ResolutionSwitch<Adapter>()
    {
      @Override
      public Adapter caseResolutionProblem(ResolutionProblem object)
      {
        return createResolutionProblemAdapter();
      }
      @Override
      public Adapter caseFormula(Formula object)
      {
        return createFormulaAdapter();
      }
      @Override
      public Adapter caseAtom(Atom object)
      {
        return createAtomAdapter();
      }
      @Override
      public Adapter caseNegatedFormula(NegatedFormula object)
      {
        return createNegatedFormulaAdapter();
      }
      @Override
      public Adapter caseConjunctiveFormula(ConjunctiveFormula object)
      {
        return createConjunctiveFormulaAdapter();
      }
      @Override
      public Adapter caseAndFormula(AndFormula object)
      {
        return createAndFormulaAdapter();
      }
      @Override
      public Adapter caseOrFormula(OrFormula object)
      {
        return createOrFormulaAdapter();
      }
      @Override
      public Adapter caseImplicationFormula(ImplicationFormula object)
      {
        return createImplicationFormulaAdapter();
      }
      @Override
      public Adapter defaultCase(EObject object)
      {
        return createEObjectAdapter();
      }
    };

  /**
   * Creates an adapter for the <code>target</code>.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param target the object to adapt.
   * @return the adapter for the <code>target</code>.
   * @generated
   */
  @Override
  public Adapter createAdapter(Notifier target)
  {
    return modelSwitch.doSwitch((EObject)target);
  }


  /**
   * Creates a new adapter for an object of class '{@link at.cl.atp.resolution.ResolutionProblem <em>Problem</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see at.cl.atp.resolution.ResolutionProblem
   * @generated
   */
  public Adapter createResolutionProblemAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link at.cl.atp.resolution.Formula <em>Formula</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see at.cl.atp.resolution.Formula
   * @generated
   */
  public Adapter createFormulaAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link at.cl.atp.resolution.Atom <em>Atom</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see at.cl.atp.resolution.Atom
   * @generated
   */
  public Adapter createAtomAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link at.cl.atp.resolution.NegatedFormula <em>Negated Formula</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see at.cl.atp.resolution.NegatedFormula
   * @generated
   */
  public Adapter createNegatedFormulaAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link at.cl.atp.resolution.ConjunctiveFormula <em>Conjunctive Formula</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see at.cl.atp.resolution.ConjunctiveFormula
   * @generated
   */
  public Adapter createConjunctiveFormulaAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link at.cl.atp.resolution.AndFormula <em>And Formula</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see at.cl.atp.resolution.AndFormula
   * @generated
   */
  public Adapter createAndFormulaAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link at.cl.atp.resolution.OrFormula <em>Or Formula</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see at.cl.atp.resolution.OrFormula
   * @generated
   */
  public Adapter createOrFormulaAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link at.cl.atp.resolution.ImplicationFormula <em>Implication Formula</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see at.cl.atp.resolution.ImplicationFormula
   * @generated
   */
  public Adapter createImplicationFormulaAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for the default case.
   * <!-- begin-user-doc -->
   * This default implementation returns null.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @generated
   */
  public Adapter createEObjectAdapter()
  {
    return null;
  }

} //ResolutionAdapterFactory
