package at.cl.atp.serializer;

import at.cl.atp.services.ResolutionGrammarAccess;
import com.google.inject.Inject;
import java.util.List;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.IGrammarAccess;
import org.eclipse.xtext.RuleCall;
import org.eclipse.xtext.nodemodel.INode;
import org.eclipse.xtext.serializer.analysis.GrammarAlias.AbstractElementAlias;
import org.eclipse.xtext.serializer.analysis.GrammarAlias.AlternativeAlias;
import org.eclipse.xtext.serializer.analysis.GrammarAlias.TokenAlias;
import org.eclipse.xtext.serializer.analysis.ISyntacticSequencerPDAProvider.ISynNavigable;
import org.eclipse.xtext.serializer.analysis.ISyntacticSequencerPDAProvider.ISynTransition;
import org.eclipse.xtext.serializer.sequencer.AbstractSyntacticSequencer;

@SuppressWarnings("all")
public class ResolutionSyntacticSequencer extends AbstractSyntacticSequencer {

	protected ResolutionGrammarAccess grammarAccess;
	protected AbstractElementAlias match_AndFormula_AmpersandKeyword_0_1_or_AndKeyword_0_0;
	protected AbstractElementAlias match_ImplicationFormula_EqualsSignGreaterThanSignKeyword_0_2_or_HyphenMinusGreaterThanSignKeyword_0_1_or_ImpKeyword_0_0;
	protected AbstractElementAlias match_NegatedFormula_ExclamationMarkKeyword_0_1_or_HyphenMinusKeyword_0_2_or_NotKeyword_0_0;
	protected AbstractElementAlias match_OrFormula_OrKeyword_0_0_or_VerticalLineKeyword_0_1;
	
	@Inject
	protected void init(IGrammarAccess access) {
		grammarAccess = (ResolutionGrammarAccess) access;
		match_AndFormula_AmpersandKeyword_0_1_or_AndKeyword_0_0 = new AlternativeAlias(false, false, new TokenAlias(false, false, grammarAccess.getAndFormulaAccess().getAmpersandKeyword_0_1()), new TokenAlias(false, false, grammarAccess.getAndFormulaAccess().getAndKeyword_0_0()));
		match_ImplicationFormula_EqualsSignGreaterThanSignKeyword_0_2_or_HyphenMinusGreaterThanSignKeyword_0_1_or_ImpKeyword_0_0 = new AlternativeAlias(false, false, new TokenAlias(false, false, grammarAccess.getImplicationFormulaAccess().getEqualsSignGreaterThanSignKeyword_0_2()), new TokenAlias(false, false, grammarAccess.getImplicationFormulaAccess().getHyphenMinusGreaterThanSignKeyword_0_1()), new TokenAlias(false, false, grammarAccess.getImplicationFormulaAccess().getImpKeyword_0_0()));
		match_NegatedFormula_ExclamationMarkKeyword_0_1_or_HyphenMinusKeyword_0_2_or_NotKeyword_0_0 = new AlternativeAlias(false, false, new TokenAlias(false, false, grammarAccess.getNegatedFormulaAccess().getExclamationMarkKeyword_0_1()), new TokenAlias(false, false, grammarAccess.getNegatedFormulaAccess().getHyphenMinusKeyword_0_2()), new TokenAlias(false, false, grammarAccess.getNegatedFormulaAccess().getNotKeyword_0_0()));
		match_OrFormula_OrKeyword_0_0_or_VerticalLineKeyword_0_1 = new AlternativeAlias(false, false, new TokenAlias(false, false, grammarAccess.getOrFormulaAccess().getOrKeyword_0_0()), new TokenAlias(false, false, grammarAccess.getOrFormulaAccess().getVerticalLineKeyword_0_1()));
	}
	
	@Override
	protected String getUnassignedRuleCallToken(EObject semanticObject, RuleCall ruleCall, INode node) {
		return "";
	}
	
	
	@Override
	protected void emitUnassignedTokens(EObject semanticObject, ISynTransition transition, INode fromNode, INode toNode) {
		if (transition.getAmbiguousSyntaxes().isEmpty()) return;
		List<INode> transitionNodes = collectNodes(fromNode, toNode);
		for (AbstractElementAlias syntax : transition.getAmbiguousSyntaxes()) {
			List<INode> syntaxNodes = getNodesFor(transitionNodes, syntax);
			if(match_AndFormula_AmpersandKeyword_0_1_or_AndKeyword_0_0.equals(syntax))
				emit_AndFormula_AmpersandKeyword_0_1_or_AndKeyword_0_0(semanticObject, getLastNavigableState(), syntaxNodes);
			else if(match_ImplicationFormula_EqualsSignGreaterThanSignKeyword_0_2_or_HyphenMinusGreaterThanSignKeyword_0_1_or_ImpKeyword_0_0.equals(syntax))
				emit_ImplicationFormula_EqualsSignGreaterThanSignKeyword_0_2_or_HyphenMinusGreaterThanSignKeyword_0_1_or_ImpKeyword_0_0(semanticObject, getLastNavigableState(), syntaxNodes);
			else if(match_NegatedFormula_ExclamationMarkKeyword_0_1_or_HyphenMinusKeyword_0_2_or_NotKeyword_0_0.equals(syntax))
				emit_NegatedFormula_ExclamationMarkKeyword_0_1_or_HyphenMinusKeyword_0_2_or_NotKeyword_0_0(semanticObject, getLastNavigableState(), syntaxNodes);
			else if(match_OrFormula_OrKeyword_0_0_or_VerticalLineKeyword_0_1.equals(syntax))
				emit_OrFormula_OrKeyword_0_0_or_VerticalLineKeyword_0_1(semanticObject, getLastNavigableState(), syntaxNodes);
			else acceptNodes(getLastNavigableState(), syntaxNodes);
		}
	}

	/**
	 * Syntax:
	 *     '&' | 'and'
	 */
	protected void emit_AndFormula_AmpersandKeyword_0_1_or_AndKeyword_0_0(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
	/**
	 * Syntax:
	 *     '=>' | '->' | 'imp'
	 */
	protected void emit_ImplicationFormula_EqualsSignGreaterThanSignKeyword_0_2_or_HyphenMinusGreaterThanSignKeyword_0_1_or_ImpKeyword_0_0(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
	/**
	 * Syntax:
	 *     'not' | '!' | '-'
	 */
	protected void emit_NegatedFormula_ExclamationMarkKeyword_0_1_or_HyphenMinusKeyword_0_2_or_NotKeyword_0_0(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
	/**
	 * Syntax:
	 *     '|' | 'or'
	 */
	protected void emit_OrFormula_OrKeyword_0_0_or_VerticalLineKeyword_0_1(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
}
