package app;

import java.util.Comparator;

import app.model.Clause;

public class ClauseSizeComparator implements Comparator<Clause> {

	@Override
	public int compare(final Clause o1, final Clause o2) {
		int size1 = o1.getAtoms().size() + o1.getNegatedAtoms().size();
		int size2 = o2.getAtoms().size() + o2.getNegatedAtoms().size();
		if (size1 < size2) {
			return -1;
		} else if (size1 > size2) {
			return 1;
		} else {
			return 0;
		}
	}

}
