/*
* generated by Xtext
*/
package at.cl.atp.ui.labeling

import com.google.inject.Inject
import at.cl.atp.tPTP.FOF_QuantifiedFormula
import at.cl.atp.tPTP.Quantifier
import at.cl.atp.tPTP.FOF_Formula
import at.cl.atp.tPTP.BinaryOperation
import at.cl.atp.tPTP.FOF_Variable
import at.cl.atp.tPTP.FOF_Constant
import at.cl.atp.tPTP.FOF_Function
import at.cl.atp.tPTP.FOF_Predicate
import at.cl.atp.tPTP.FOF_NegatedFormula
import at.cl.atp.tPTP.CNF_annotated
import at.cl.atp.tPTP.ROLE

/**
 * Provides labels for a EObjects.
 * 
 * see http://www.eclipse.org/Xtext/documentation.html#labelProvider
 */
class TPTPLabelProvider extends org.eclipse.xtext.ui.label.DefaultEObjectLabelProvider {

	@Inject
	new(org.eclipse.emf.edit.ui.provider.AdapterFactoryLabelProvider delegate) {
		super(delegate);
	}

	def text(FOF_QuantifiedFormula formula){
		val StringBuilder builder = new StringBuilder();
		builder.append(formula.quantifier.literal);
		builder.append("[");
		val int max = formula.variables.size;
		(0 ..< max).forEach[index |
			builder.append(formula.variables.get(index));
			if((index+1) < max){
				builder.append(", ");
			}
		]
		builder.append("]");
		return builder.toString();
	}

	def image(FOF_QuantifiedFormula formula){
		switch(formula.quantifier){
			case Quantifier::EXISTENTIAL: return "exists.png"
			case Quantifier::UNIVERSAL: return "forall.png"
		}
	}
	
	
	def text(FOF_Formula formula){
		switch(formula.operation){
			case BinaryOperation::CONJUNCTION: return 'and'
			case BinaryOperation::DISJUNCTION: return 'or'
			case BinaryOperation::IMPLICATION: return '=>'
		}
	}
	
	def image(FOF_Formula formula){
		switch(formula.operation){
			case BinaryOperation::CONJUNCTION: return 'conjunction.png'
			case BinaryOperation::DISJUNCTION: return 'disjunction.png'
			case BinaryOperation::IMPLICATION: return 'implication.png'
		}
	}

	def image(FOF_Variable variable){
		return 'variable.png'
	}
	
	def text(FOF_Variable variable){
		return variable.name
	}
	
	def image(FOF_Constant constant){
		return 'constant.png'
	}
	
	def text(FOF_Constant constant){
		return constant.name
	}
	
	def image(FOF_Function function){
		return 'function.png'
	}
	
	def text(FOF_Function function){
		return function.name
	}
	
	def image(FOF_Predicate predicate){
		return 'predicate.png'
	}
	
	def text(FOF_Predicate predicate){
		return predicate.name
	}
	
	def text(FOF_NegatedFormula negation){
		return '!'
	}
	
	def image(FOF_NegatedFormula negation){
		return 'negation.png'
	}

	def image(CNF_annotated cnf){
		if(cnf.role == ROLE::CONJECTURE){
			return "conjecture.png"
		}else if(cnf.role == ROLE::HYPOTHESIS){
			return "hypothesis.png"
		}else if(cnf.role == ROLE::NEGATED_CONJECTURE){
			return "negatedConjecture.png"
		}
	}

	// Labels and icons can be computed like this:
	
//	def text(Greeting ele) {
//		'A greeting to ' + ele.name
//	}
//
//	def image(Greeting ele) {
//		'Greeting.gif'
//	}
}
