/**
 * generated by Xtext
 */
package at.cl.atp.ui.labeling;

import at.cl.atp.tPTP.BinaryOperation;
import at.cl.atp.tPTP.CNF_annotated;
import at.cl.atp.tPTP.FOF_Constant;
import at.cl.atp.tPTP.FOF_Formula;
import at.cl.atp.tPTP.FOF_Function;
import at.cl.atp.tPTP.FOF_NegatedFormula;
import at.cl.atp.tPTP.FOF_Predicate;
import at.cl.atp.tPTP.FOF_QuantifiedFormula;
import at.cl.atp.tPTP.FOF_Variable;
import at.cl.atp.tPTP.Quantifier;
import at.cl.atp.tPTP.ROLE;
import com.google.common.base.Objects;
import com.google.inject.Inject;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.edit.ui.provider.AdapterFactoryLabelProvider;
import org.eclipse.xtext.ui.label.DefaultEObjectLabelProvider;
import org.eclipse.xtext.xbase.lib.ExclusiveRange;
import org.eclipse.xtext.xbase.lib.IterableExtensions;
import org.eclipse.xtext.xbase.lib.Procedures.Procedure1;

/**
 * Provides labels for a EObjects.
 * 
 * see http://www.eclipse.org/Xtext/documentation.html#labelProvider
 */
@SuppressWarnings("all")
public class TPTPLabelProvider extends DefaultEObjectLabelProvider {
  @Inject
  public TPTPLabelProvider(final AdapterFactoryLabelProvider delegate) {
    super(delegate);
  }
  
  public String text(final FOF_QuantifiedFormula formula) {
    StringBuilder _stringBuilder = new StringBuilder();
    final StringBuilder builder = _stringBuilder;
    Quantifier _quantifier = formula.getQuantifier();
    String _literal = _quantifier.getLiteral();
    builder.append(_literal);
    builder.append("[");
    EList<String> _variables = formula.getVariables();
    final int max = _variables.size();
    ExclusiveRange _doubleDotLessThan = new ExclusiveRange(0, max, true);
    final Procedure1<Integer> _function = new Procedure1<Integer>() {
        public void apply(final Integer index) {
          EList<String> _variables = formula.getVariables();
          String _get = _variables.get((index).intValue());
          builder.append(_get);
          int _plus = ((index).intValue() + 1);
          boolean _lessThan = (_plus < max);
          if (_lessThan) {
            builder.append(", ");
          }
        }
      };
    IterableExtensions.<Integer>forEach(_doubleDotLessThan, _function);
    builder.append("]");
    return builder.toString();
  }
  
  public String image(final FOF_QuantifiedFormula formula) {
    String _switchResult = null;
    Quantifier _quantifier = formula.getQuantifier();
    final Quantifier _switchValue = _quantifier;
    boolean _matched = false;
    if (!_matched) {
      if (Objects.equal(_switchValue,Quantifier.EXISTENTIAL)) {
        _matched=true;
        return "exists.png";
      }
    }
    if (!_matched) {
      if (Objects.equal(_switchValue,Quantifier.UNIVERSAL)) {
        _matched=true;
        return "forall.png";
      }
    }
    return _switchResult;
  }
  
  public String text(final FOF_Formula formula) {
    String _switchResult = null;
    BinaryOperation _operation = formula.getOperation();
    final BinaryOperation _switchValue = _operation;
    boolean _matched = false;
    if (!_matched) {
      if (Objects.equal(_switchValue,BinaryOperation.CONJUNCTION)) {
        _matched=true;
        return "and";
      }
    }
    if (!_matched) {
      if (Objects.equal(_switchValue,BinaryOperation.DISJUNCTION)) {
        _matched=true;
        return "or";
      }
    }
    if (!_matched) {
      if (Objects.equal(_switchValue,BinaryOperation.IMPLICATION)) {
        _matched=true;
        return "=>";
      }
    }
    return _switchResult;
  }
  
  public String image(final FOF_Formula formula) {
    String _switchResult = null;
    BinaryOperation _operation = formula.getOperation();
    final BinaryOperation _switchValue = _operation;
    boolean _matched = false;
    if (!_matched) {
      if (Objects.equal(_switchValue,BinaryOperation.CONJUNCTION)) {
        _matched=true;
        return "conjunction.png";
      }
    }
    if (!_matched) {
      if (Objects.equal(_switchValue,BinaryOperation.DISJUNCTION)) {
        _matched=true;
        return "disjunction.png";
      }
    }
    if (!_matched) {
      if (Objects.equal(_switchValue,BinaryOperation.IMPLICATION)) {
        _matched=true;
        return "implication.png";
      }
    }
    return _switchResult;
  }
  
  public String image(final FOF_Variable variable) {
    return "variable.png";
  }
  
  public String text(final FOF_Variable variable) {
    return variable.getName();
  }
  
  public String image(final FOF_Constant constant) {
    return "constant.png";
  }
  
  public String text(final FOF_Constant constant) {
    return constant.getName();
  }
  
  public String image(final FOF_Function function) {
    return "function.png";
  }
  
  public String text(final FOF_Function function) {
    return function.getName();
  }
  
  public String image(final FOF_Predicate predicate) {
    return "predicate.png";
  }
  
  public String text(final FOF_Predicate predicate) {
    return predicate.getName();
  }
  
  public String text(final FOF_NegatedFormula negation) {
    return "!";
  }
  
  public String image(final FOF_NegatedFormula negation) {
    return "negation.png";
  }
  
  public String image(final CNF_annotated cnf) {
    String _xifexpression = null;
    ROLE _role = cnf.getRole();
    boolean _equals = Objects.equal(_role, ROLE.CONJECTURE);
    if (_equals) {
      return "conjecture.png";
    } else {
      String _xifexpression_1 = null;
      ROLE _role_1 = cnf.getRole();
      boolean _equals_1 = Objects.equal(_role_1, ROLE.HYPOTHESIS);
      if (_equals_1) {
        return "hypothesis.png";
      } else {
        String _xifexpression_2 = null;
        ROLE _role_2 = cnf.getRole();
        boolean _equals_2 = Objects.equal(_role_2, ROLE.NEGATED_CONJECTURE);
        if (_equals_2) {
          return "negatedConjecture.png";
        }
        _xifexpression_1 = _xifexpression_2;
      }
      _xifexpression = _xifexpression_1;
    }
    return _xifexpression;
  }
}
