/**
 */
package at.cl.atp.tPTP.impl;

import at.cl.atp.tPTP.*;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class TPTPFactoryImpl extends EFactoryImpl implements TPTPFactory
{
  /**
   * Creates the default factory implementation.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static TPTPFactory init()
  {
    try
    {
      TPTPFactory theTPTPFactory = (TPTPFactory)EPackage.Registry.INSTANCE.getEFactory("http://www.cl.at/atp/TPTP"); 
      if (theTPTPFactory != null)
      {
        return theTPTPFactory;
      }
    }
    catch (Exception exception)
    {
      EcorePlugin.INSTANCE.log(exception);
    }
    return new TPTPFactoryImpl();
  }

  /**
   * Creates an instance of the factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public TPTPFactoryImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EObject create(EClass eClass)
  {
    switch (eClass.getClassifierID())
    {
      case TPTPPackage.TPTP_FILE: return createTPTP_File();
      case TPTPPackage.ANNOTATED_FORMULA: return createAnnotated_formula();
      case TPTPPackage.CNF_ANNOTATED: return createCNF_annotated();
      case TPTPPackage.FOF_FORMULA: return createFOF_Formula();
      case TPTPPackage.FOF_QUANTIFIED_FORMULA: return createFOF_QuantifiedFormula();
      case TPTPPackage.FOF_NEGATED_FORMULA: return createFOF_NegatedFormula();
      case TPTPPackage.FOF_PREDICATE: return createFOF_Predicate();
      case TPTPPackage.FOF_FUNCTION: return createFOF_Function();
      case TPTPPackage.FOF_ATOM: return createFOF_Atom();
      case TPTPPackage.FOF_VARIABLE: return createFOF_Variable();
      case TPTPPackage.FOF_CONSTANT: return createFOF_Constant();
      default:
        throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
    }
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object createFromString(EDataType eDataType, String initialValue)
  {
    switch (eDataType.getClassifierID())
    {
      case TPTPPackage.BINARY_OPERATION:
        return createBinaryOperationFromString(eDataType, initialValue);
      case TPTPPackage.QUANTIFIER:
        return createQuantifierFromString(eDataType, initialValue);
      case TPTPPackage.ROLE:
        return createROLEFromString(eDataType, initialValue);
      default:
        throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
    }
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String convertToString(EDataType eDataType, Object instanceValue)
  {
    switch (eDataType.getClassifierID())
    {
      case TPTPPackage.BINARY_OPERATION:
        return convertBinaryOperationToString(eDataType, instanceValue);
      case TPTPPackage.QUANTIFIER:
        return convertQuantifierToString(eDataType, instanceValue);
      case TPTPPackage.ROLE:
        return convertROLEToString(eDataType, instanceValue);
      default:
        throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
    }
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public TPTP_File createTPTP_File()
  {
    TPTP_FileImpl tptP_File = new TPTP_FileImpl();
    return tptP_File;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Annotated_formula createAnnotated_formula()
  {
    Annotated_formulaImpl annotated_formula = new Annotated_formulaImpl();
    return annotated_formula;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public CNF_annotated createCNF_annotated()
  {
    CNF_annotatedImpl cnF_annotated = new CNF_annotatedImpl();
    return cnF_annotated;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FOF_Formula createFOF_Formula()
  {
    FOF_FormulaImpl foF_Formula = new FOF_FormulaImpl();
    return foF_Formula;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FOF_QuantifiedFormula createFOF_QuantifiedFormula()
  {
    FOF_QuantifiedFormulaImpl foF_QuantifiedFormula = new FOF_QuantifiedFormulaImpl();
    return foF_QuantifiedFormula;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FOF_NegatedFormula createFOF_NegatedFormula()
  {
    FOF_NegatedFormulaImpl foF_NegatedFormula = new FOF_NegatedFormulaImpl();
    return foF_NegatedFormula;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FOF_Predicate createFOF_Predicate()
  {
    FOF_PredicateImpl foF_Predicate = new FOF_PredicateImpl();
    return foF_Predicate;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FOF_Function createFOF_Function()
  {
    FOF_FunctionImpl foF_Function = new FOF_FunctionImpl();
    return foF_Function;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FOF_Atom createFOF_Atom()
  {
    FOF_AtomImpl foF_Atom = new FOF_AtomImpl();
    return foF_Atom;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FOF_Variable createFOF_Variable()
  {
    FOF_VariableImpl foF_Variable = new FOF_VariableImpl();
    return foF_Variable;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FOF_Constant createFOF_Constant()
  {
    FOF_ConstantImpl foF_Constant = new FOF_ConstantImpl();
    return foF_Constant;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public BinaryOperation createBinaryOperationFromString(EDataType eDataType, String initialValue)
  {
    BinaryOperation result = BinaryOperation.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertBinaryOperationToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Quantifier createQuantifierFromString(EDataType eDataType, String initialValue)
  {
    Quantifier result = Quantifier.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertQuantifierToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ROLE createROLEFromString(EDataType eDataType, String initialValue)
  {
    ROLE result = ROLE.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertROLEToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public TPTPPackage getTPTPPackage()
  {
    return (TPTPPackage)getEPackage();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @deprecated
   * @generated
   */
  @Deprecated
  public static TPTPPackage getPackage()
  {
    return TPTPPackage.eINSTANCE;
  }

} //TPTPFactoryImpl
