/**
 */
package at.cl.atp.tPTP.util;

import at.cl.atp.tPTP.*;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see at.cl.atp.tPTP.TPTPPackage
 * @generated
 */
public class TPTPAdapterFactory extends AdapterFactoryImpl
{
  /**
   * The cached model package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected static TPTPPackage modelPackage;

  /**
   * Creates an instance of the adapter factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public TPTPAdapterFactory()
  {
    if (modelPackage == null)
    {
      modelPackage = TPTPPackage.eINSTANCE;
    }
  }

  /**
   * Returns whether this factory is applicable for the type of the object.
   * <!-- begin-user-doc -->
   * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
   * <!-- end-user-doc -->
   * @return whether this factory is applicable for the type of the object.
   * @generated
   */
  @Override
  public boolean isFactoryForType(Object object)
  {
    if (object == modelPackage)
    {
      return true;
    }
    if (object instanceof EObject)
    {
      return ((EObject)object).eClass().getEPackage() == modelPackage;
    }
    return false;
  }

  /**
   * The switch that delegates to the <code>createXXX</code> methods.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TPTPSwitch<Adapter> modelSwitch =
    new TPTPSwitch<Adapter>()
    {
      @Override
      public Adapter caseTPTP_File(TPTP_File object)
      {
        return createTPTP_FileAdapter();
      }
      @Override
      public Adapter caseAnnotated_formula(Annotated_formula object)
      {
        return createAnnotated_formulaAdapter();
      }
      @Override
      public Adapter caseCNF_annotated(CNF_annotated object)
      {
        return createCNF_annotatedAdapter();
      }
      @Override
      public Adapter caseFOF_Formula(FOF_Formula object)
      {
        return createFOF_FormulaAdapter();
      }
      @Override
      public Adapter caseFOF_QuantifiedFormula(FOF_QuantifiedFormula object)
      {
        return createFOF_QuantifiedFormulaAdapter();
      }
      @Override
      public Adapter caseFOF_NegatedFormula(FOF_NegatedFormula object)
      {
        return createFOF_NegatedFormulaAdapter();
      }
      @Override
      public Adapter caseFOF_Predicate(FOF_Predicate object)
      {
        return createFOF_PredicateAdapter();
      }
      @Override
      public Adapter caseFOF_Function(FOF_Function object)
      {
        return createFOF_FunctionAdapter();
      }
      @Override
      public Adapter caseFOF_Atom(FOF_Atom object)
      {
        return createFOF_AtomAdapter();
      }
      @Override
      public Adapter caseFOF_Variable(FOF_Variable object)
      {
        return createFOF_VariableAdapter();
      }
      @Override
      public Adapter caseFOF_Constant(FOF_Constant object)
      {
        return createFOF_ConstantAdapter();
      }
      @Override
      public Adapter defaultCase(EObject object)
      {
        return createEObjectAdapter();
      }
    };

  /**
   * Creates an adapter for the <code>target</code>.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param target the object to adapt.
   * @return the adapter for the <code>target</code>.
   * @generated
   */
  @Override
  public Adapter createAdapter(Notifier target)
  {
    return modelSwitch.doSwitch((EObject)target);
  }


  /**
   * Creates a new adapter for an object of class '{@link at.cl.atp.tPTP.TPTP_File <em>TPTP File</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see at.cl.atp.tPTP.TPTP_File
   * @generated
   */
  public Adapter createTPTP_FileAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link at.cl.atp.tPTP.Annotated_formula <em>Annotated formula</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see at.cl.atp.tPTP.Annotated_formula
   * @generated
   */
  public Adapter createAnnotated_formulaAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link at.cl.atp.tPTP.CNF_annotated <em>CNF annotated</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see at.cl.atp.tPTP.CNF_annotated
   * @generated
   */
  public Adapter createCNF_annotatedAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link at.cl.atp.tPTP.FOF_Formula <em>FOF Formula</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see at.cl.atp.tPTP.FOF_Formula
   * @generated
   */
  public Adapter createFOF_FormulaAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link at.cl.atp.tPTP.FOF_QuantifiedFormula <em>FOF Quantified Formula</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see at.cl.atp.tPTP.FOF_QuantifiedFormula
   * @generated
   */
  public Adapter createFOF_QuantifiedFormulaAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link at.cl.atp.tPTP.FOF_NegatedFormula <em>FOF Negated Formula</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see at.cl.atp.tPTP.FOF_NegatedFormula
   * @generated
   */
  public Adapter createFOF_NegatedFormulaAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link at.cl.atp.tPTP.FOF_Predicate <em>FOF Predicate</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see at.cl.atp.tPTP.FOF_Predicate
   * @generated
   */
  public Adapter createFOF_PredicateAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link at.cl.atp.tPTP.FOF_Function <em>FOF Function</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see at.cl.atp.tPTP.FOF_Function
   * @generated
   */
  public Adapter createFOF_FunctionAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link at.cl.atp.tPTP.FOF_Atom <em>FOF Atom</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see at.cl.atp.tPTP.FOF_Atom
   * @generated
   */
  public Adapter createFOF_AtomAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link at.cl.atp.tPTP.FOF_Variable <em>FOF Variable</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see at.cl.atp.tPTP.FOF_Variable
   * @generated
   */
  public Adapter createFOF_VariableAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link at.cl.atp.tPTP.FOF_Constant <em>FOF Constant</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see at.cl.atp.tPTP.FOF_Constant
   * @generated
   */
  public Adapter createFOF_ConstantAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for the default case.
   * <!-- begin-user-doc -->
   * This default implementation returns null.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @generated
   */
  public Adapter createEObjectAdapter()
  {
    return null;
  }

} //TPTPAdapterFactory
