/**
 */
package at.cl.atp.tPTP.util;

import at.cl.atp.tPTP.*;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.util.Switch;

/**
 * <!-- begin-user-doc -->
 * The <b>Switch</b> for the model's inheritance hierarchy.
 * It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object
 * and proceeding up the inheritance hierarchy
 * until a non-null result is returned,
 * which is the result of the switch.
 * <!-- end-user-doc -->
 * @see at.cl.atp.tPTP.TPTPPackage
 * @generated
 */
public class TPTPSwitch<T> extends Switch<T>
{
  /**
   * The cached model package
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected static TPTPPackage modelPackage;

  /**
   * Creates an instance of the switch.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public TPTPSwitch()
  {
    if (modelPackage == null)
    {
      modelPackage = TPTPPackage.eINSTANCE;
    }
  }

  /**
   * Checks whether this is a switch for the given package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @parameter ePackage the package in question.
   * @return whether this is a switch for the given package.
   * @generated
   */
  @Override
  protected boolean isSwitchFor(EPackage ePackage)
  {
    return ePackage == modelPackage;
  }

  /**
   * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the first non-null result returned by a <code>caseXXX</code> call.
   * @generated
   */
  @Override
  protected T doSwitch(int classifierID, EObject theEObject)
  {
    switch (classifierID)
    {
      case TPTPPackage.TPTP_FILE:
      {
        TPTP_File tptP_File = (TPTP_File)theEObject;
        T result = caseTPTP_File(tptP_File);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case TPTPPackage.ANNOTATED_FORMULA:
      {
        Annotated_formula annotated_formula = (Annotated_formula)theEObject;
        T result = caseAnnotated_formula(annotated_formula);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case TPTPPackage.CNF_ANNOTATED:
      {
        CNF_annotated cnF_annotated = (CNF_annotated)theEObject;
        T result = caseCNF_annotated(cnF_annotated);
        if (result == null) result = caseAnnotated_formula(cnF_annotated);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case TPTPPackage.FOF_FORMULA:
      {
        FOF_Formula foF_Formula = (FOF_Formula)theEObject;
        T result = caseFOF_Formula(foF_Formula);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case TPTPPackage.FOF_QUANTIFIED_FORMULA:
      {
        FOF_QuantifiedFormula foF_QuantifiedFormula = (FOF_QuantifiedFormula)theEObject;
        T result = caseFOF_QuantifiedFormula(foF_QuantifiedFormula);
        if (result == null) result = caseFOF_Formula(foF_QuantifiedFormula);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case TPTPPackage.FOF_NEGATED_FORMULA:
      {
        FOF_NegatedFormula foF_NegatedFormula = (FOF_NegatedFormula)theEObject;
        T result = caseFOF_NegatedFormula(foF_NegatedFormula);
        if (result == null) result = caseFOF_Formula(foF_NegatedFormula);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case TPTPPackage.FOF_PREDICATE:
      {
        FOF_Predicate foF_Predicate = (FOF_Predicate)theEObject;
        T result = caseFOF_Predicate(foF_Predicate);
        if (result == null) result = caseFOF_Formula(foF_Predicate);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case TPTPPackage.FOF_FUNCTION:
      {
        FOF_Function foF_Function = (FOF_Function)theEObject;
        T result = caseFOF_Function(foF_Function);
        if (result == null) result = caseFOF_Formula(foF_Function);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case TPTPPackage.FOF_ATOM:
      {
        FOF_Atom foF_Atom = (FOF_Atom)theEObject;
        T result = caseFOF_Atom(foF_Atom);
        if (result == null) result = caseFOF_Formula(foF_Atom);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case TPTPPackage.FOF_VARIABLE:
      {
        FOF_Variable foF_Variable = (FOF_Variable)theEObject;
        T result = caseFOF_Variable(foF_Variable);
        if (result == null) result = caseFOF_Atom(foF_Variable);
        if (result == null) result = caseFOF_Formula(foF_Variable);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case TPTPPackage.FOF_CONSTANT:
      {
        FOF_Constant foF_Constant = (FOF_Constant)theEObject;
        T result = caseFOF_Constant(foF_Constant);
        if (result == null) result = caseFOF_Atom(foF_Constant);
        if (result == null) result = caseFOF_Formula(foF_Constant);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      default: return defaultCase(theEObject);
    }
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>TPTP File</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>TPTP File</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseTPTP_File(TPTP_File object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Annotated formula</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Annotated formula</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseAnnotated_formula(Annotated_formula object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>CNF annotated</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>CNF annotated</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseCNF_annotated(CNF_annotated object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>FOF Formula</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>FOF Formula</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseFOF_Formula(FOF_Formula object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>FOF Quantified Formula</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>FOF Quantified Formula</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseFOF_QuantifiedFormula(FOF_QuantifiedFormula object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>FOF Negated Formula</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>FOF Negated Formula</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseFOF_NegatedFormula(FOF_NegatedFormula object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>FOF Predicate</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>FOF Predicate</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseFOF_Predicate(FOF_Predicate object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>FOF Function</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>FOF Function</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseFOF_Function(FOF_Function object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>FOF Atom</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>FOF Atom</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseFOF_Atom(FOF_Atom object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>FOF Variable</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>FOF Variable</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseFOF_Variable(FOF_Variable object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>FOF Constant</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>FOF Constant</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseFOF_Constant(FOF_Constant object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>EObject</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch, but this is the last case anyway.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>EObject</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject)
   * @generated
   */
  @Override
  public T defaultCase(EObject object)
  {
    return null;
  }

} //TPTPSwitch
